<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyMessage by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined ( '_JEXEC' ) or die ( 'Restricted access' );

jimport('joomla.application.component.controller');
class InboxControllerCnf extends JController
{

	function __construct()
	{
		parent::__construct();
		$this->registerTask( 'apply', 'save' );
		JRequest::setVar( 'view', 'cnf' );
	}

	function display()
	{
		JRequest::setVar('view', 'cnf');
		parent::display();
	}

	function save()
	{
		global $mainframe;

		$task = JRequest::getCmd( 'task' );

		foreach ( $_POST['params'] as $var => $val ) {
			if(is_array($val)) $_POST['params'][$var] = serialize($val);
		}

		$params = new JParameter( $_POST['params'], JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jsinbox'.DS.'params.xml' );
		$params->bind( $_POST['params'] );
		$ini = $params->toString();

		JFile::write( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jsinbox'.DS.'config.ini', $ini );

		$msg = JText::_( 'Successfully Saved Configuration' );
		switch ( $task ) {
			case 'apply':
				$link = 'index.php?option=com_jsinbox&controller=cnf';
				break;
			default:
				$link = 'index.php?option=com_jsinbox';
				break;
		}
		$mainframe->redirect($link , $msg );
	}

	function cancel()
	{
		global $mainframe;
		$link = 'index.php?option=com_jsinbox';
		$mainframe->redirect( $link );
	}

	function set( $key, $value, $group = '_default' )
	{
		global $JS_params_obj;

		if( ! isset( $JS_params_obj ) ){
			JError::raiseWarning( 500, JText::_('Config controller is not initialised') );
			return false;
		}

		$JS_params_obj->set( $key, $value, $group );

		$ini = $JS_params_obj->toString();

		JFile::write( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jsinbox'.DS.'config.ini', $ini );

		return true;
	}

	function initialyze()
	{
		$uri = & JFactory::getURI();

		$path = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jsinbox'.DS.'config.ini';
		if (!is_file($path))
			return false;
		
		$ini = JFile::read( $path );

		$config_params = new JParameter( $ini, JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jsinbox'.DS.'params.xml' );

		$GLOBALS[ 'JS_params_obj' ] = $config_params ;

		$params_array = $config_params->toArray();

		foreach($params_array AS $key => $val){
			$name = strtoupper('INBOX_'.$key);
			if(defined(strtoupper($name))){
				print $name;
				continue;
			}

			define(strtoupper($name), $val, true);
		}
	}
}
?>