<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyMessage by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined ( '_JEXEC' ) or die ( 'Restricted access' );

jimport('joomla.application.component.controller');
class InboxControllerTypes extends JController
{

  function __construct()
  {
    parent::__construct();
    $this->registerTask( 'apply', 'save' );
    $this->registerTask( 'add', 'edit' );
    $this->registerTask( 'unpublish', 'publish' );
    
    if( !JRequest::getVar( "view" ) ) {
      JRequest::setVar( 'view', 'types' );
    }
  }

  function display()
  {
    parent::display();
  }
  
  function edit()
  {
  	if( JRequest::getCmd( 'task' ) == 'add' ) {
      JRequest::setVar( 'cid', '' );  		
  	}
  	
  	JRequest::setVar( 'layout', 'form' );
  	parent::display();
  }
  
  function makeDef()
  {
    global $mainframe;
    
    $model = $this->getModel ( 'Types', 'InboxModel' );
    
    if ( $model->makeDef() ) {
      $mainframe->enqueueMessage( JText::_ ( 'Types set as Default' ) );
    } else {
      JError::raiseWarning( JText::_ ( 'Error seting type as Default' )  );
    }

    $this->cancel();
  }
    
  function publish()
  {
  	global $mainframe;
    
  	$task = JRequest::getCmd( 'task' );
  	
    $model = $this->getModel ( 'Types', 'InboxModel' );
    
    if ( $model->publish() ) {
      $mainframe->enqueueMessage( $task == "publish" ? JText::_ ( 'Types Published' ) : JText::_ ( 'Types Unpublished' ) );
    } else {
      JError::raiseWarning( ( $task == "publish" ? JText::_ ( 'Error Published Types' ) : JText::_ ( 'Error Unpublished Types' ) ). '<br>' . $model->getError () );
    }

    $this->cancel();
  }
  
  function remove()
  {
  	global $mainframe;
  	
  	$model = $this->getModel ( 'Types', 'InboxModel' );
  	
    if ( $model->remove() ) {
    	$mainframe->enqueueMessage( JText::_ ( 'Types removed' ) );
    } else {
      JError::raiseWarning( JText::_ ( 'Error Removing Types' ) . '<br>' . $model->getError () );
    }

    $this->cancel();
  }
  
  function save()
  {
    global $mainframe;

    $post = JRequest::get ( 'post' );
    $cid = JRequest::getVar ( 'cid', array ( 0 ), 'post', 'array' );
    $post ['id'] = ( int ) $cid [0];
    
    $model = $this->getModel ( 'Types', 'InboxModel' );
    
    if ( $model->store ( $post ) ) {
      $mainframe->enqueueMessage( JText::_ ( 'Type Saved' ) );
    } else {
      JError::raiseWarning( JText::_ ( 'Error Saving Type' ) . '<br>' . $model->getError () );
    }
    
    $model->checkin ();
    
    $task = JRequest::getCmd( 'task' );

    switch ( $task ) {
  		case 'apply':
  			$mainframe->redirect( 'index.php?option=com_jsinbox&controller=types&task=edit&cid[]='.$model->_id );
  			break;
  		case 'save':
  		default:
  			$this->cancel();
  			break;
  	}
  }

  function cancel()
  {
    global $mainframe;
    $link = 'index.php?option=com_jsinbox&controller=types';
    $mainframe->redirect( $link );
  }
  
	function support()
	{
		$doc = &JFactory::getDocument();
		$js = 'window.open("http://support.mightyextensions.com/en/mighty-message-joomla-component.html")';
		$doc->addScriptDeclaration($js);
		JRequest::setVar( 'view'  , 'types');
		parent::display();
	}
}
?>