<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyMessage by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined ( '_JEXEC' ) or die ();

jimport ( 'joomla.application.component.model' );

class InboxModelTypes extends JModel {
	var $_data = null;
	
	function __construct() {
		parent::__construct ();
		
		$array = JRequest::getVar ( 'cid', array (0 ), '', 'array' );
		$this->setId ( ( int ) $array [0] );
	}
	function setId($id) {
		$this->_id = $id;
		$this->_data = null;
	}
	
  function getResourceFields( $resource_type_id )
  {
    $query = "   SELECT *"
          ."\n     FROM #__js_res_fields"
          ."\n    WHERE type_id = ".$resource_type_id." AND published = 1"
          ."\n GROUP BY id "
          ."\n ORDER BY ordering "
          ;
    $fields = $this->_getList ( $query );
    return $fields; 
  }
	
	function getTypes() {
		if (empty ( $this->_data )) {
			$query = $this->_MQuery ();
			
			$this->_data = $this->_getList ( $query );
		}
		
		return $this->_data;
	}
	
	function _MQuery() {
		$orderby = $this->_OrderBy ();
		
		$query = "   SELECT *"
		      ."\n     FROM #__js_inbox_types"
		      ."\n GROUP BY id "
		      ."\n ".$orderby;
		return $query;
	}
	
	function _OrderBy() {
		global $mainframe, $option;
		
		$filter_order     = $mainframe->getUserStateFromRequest ( $option . 'types.filter_order',     'filter_order',     'name', 'cmd' );
		$filter_order_Dir = $mainframe->getUserStateFromRequest ( $option . 'types.filter_order_Dir', 'filter_order_Dir', 'ASC',  'word' );
		
		$orderby = '';
		if ($filter_order && $filter_order_Dir) {
			$orderby = 'ORDER BY ' . $filter_order . ' ' . $filter_order_Dir;
		}

			return $orderby;
	}
	
	function &getType() {
		$this->_SLoadData ();
		
		return $this->_data;
	}
	
function &getDefaultType() {
    $this->_db->setQuery( "SELECT id FROM #__js_inbox_types WHERE def = 1" );
    $def_id = $this->_db->loadResult();
    $def_type = & $this->getTable();
    $def_type->load( $def_id );
    
    return $def_type;
  }
	
	function isCheckedOut($uid = 0) {
		if ( $this->_SLoadData () ) {
			if ( $uid ) {
				return ( $this->_data->checked_out && $this->_data->checked_out != $uid );
			} else {
				return $this->_data->checked_out;
			}
		}
	}
	
	function _SLoadData() {
		if ( empty ( $this->_data ) ) {
			$this->_data = & $this->getTable ();
			$this->_data->load( $this->_id );
		}
		return true;
	}
	
	function checkout($uid = null) {
		if ( $this->_SLoadData () ) {
			if (is_null ( $uid )) {
				$user = & JFactory::getUser ();
				$uid = $user->get ( 'id' );
			}
			
		if (! $this->_data->checkout ( $uid, $this->_id )) {
        $this->setError ( $this->_db->getErrorMsg () );
        return false;
      }
			
			return true;
		}
		return false;
	}
	
	function store( $data ) {
		$row = & $this->getTable ();
		
		if( isset( $data[ 'id' ] ) && $data[ 'id' ] ) {
		  $row->load ( $data[ 'id' ] );
		}
		
		if ( ! $row->bind ( $data ) ) {
			$this->setError ( $row->getError () );
			return false;
		}
		
		if ( ! $row->check () ) {
			$this->setError ( $row->getError () );
			return false;
		}
		
		if ( ! $row->store () ) {
			$this->setError ( $row->getError () );
			return false;
		}
    $this->_id = $row->id;
		return true;
	}
	
	function checkin() {
		if ( $this->_SLoadData () ) {
			if (! $this->_data->checkin ( $this->_id )) {
				$this->setError ( $this->_db->getErrorMsg () );
				return false;
			}
		}
		return false;
	}
	
	function remove()
	{
		$cid  = JRequest::getVar( 'cid', array( 0 ) );
    $cids = implode( ", ", $cid );
    
    $this->_db->setQuery( "DELETE FROM #__js_inbox_types WHERE id IN ( ".$cids." )" );
    
    if( ! $this->_db->query() ) {
      $this->setError ( $this->_db->getErrorMsg () );
      return false;
    }
    
    $def_type = $this->getDefaultType();
    
    $this->_db->setQuery( "UPDATE #__js_inbox_messages SET type_id = ".$def_type->get( "id" )." WHERE type_id IN ( ".$cids." )" );
    $this->_db->query();
    
    return true;
	}
	
  function makeDef()
  {
    $cid  = JRequest::getVar( 'cid', array( 0 ) );
     
    if ( count( $cid ) ) {

    	$query = 'UPDATE #__js_inbox_types SET def = IF( id = '.(int)$cid[0].' , 1 , 0)';

      $this->_db->setQuery( $query );
      if (!$this->_db->query()) {
        $this->setError($this->_db->getErrorMsg());
        return false;
      }
    }
    return true;
  }
  
  function publish()
  {
    $user   =& JFactory::getUser();

    $cid  = JRequest::getVar( 'cid', array( 0 ) );
    $task = JRequest::getCmd( 'task' );
    
    $publish = ( $task == 'publish' ? 1 : 0 );
     
    if ( count( $cid ) ) {
      JArrayHelper::toInteger( $cid );
      $cids = implode( ',', $cid );

      $query = 'UPDATE #__js_inbox_types'
        . ' SET published = '.(int) $publish
        . ' WHERE id IN ( '.$cids.' )'
        . ' AND ( checked_out = 0 OR ( checked_out = '.(int) $user->get('id').' ) )'
      ;
      $this->_db->setQuery( $query );
      if (!$this->_db->query()) {
        $this->setError($this->_db->getErrorMsg());
        return false;
      }
    }
    return true;
  }
}