CREATE TABLE IF NOT EXISTS  `#__js_inbox` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `message_id` int(10) unsigned NOT NULL default '0',
  `folder_id` int(10) unsigned NOT NULL default '0',
  `user_id` int(10) unsigned NOT NULL default '0' COMMENT 'User which must see message_id message in folder_id folder',
  `flag` text,
  `trash` tinyint(1) unsigned NOT NULL default '0',
  `_read` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS  `#__js_inbox_address_book` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `user_id_from` int(10) unsigned NOT NULL default '0',
  `user_id_to` int(10) unsigned NOT NULL default '0',
  `type_id` int(10) unsigned NOT NULL default '0',
  `amount` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS  `#__js_inbox_draft` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `message_id` int(10) unsigned NOT NULL default '0',
  `user_id` int(10) unsigned NOT NULL default '0',
  `flag` text NOT NULL,
  `trash` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS  `#__js_inbox_folders` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `title` text NOT NULL,
  `description` text NOT NULL,
  `purpose` varchar(45) NOT NULL default '',
  `icon` varchar(45) NOT NULL default '',
  `params` varchar(45) NOT NULL default '',
  `user_id` int(10) unsigned NOT NULL default '0',
  `global` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS  `#__js_inbox_history` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `event` tinyint(2) unsigned NOT NULL default '0',
  `who` text NOT NULL,
  `whom` text NOT NULL,
  `when` datetime NOT NULL default '0000-00-00 00:00:00',
  `what` text NOT NULL,
  `_read` tinyint(1) NOT NULL default '0',
  `params` text NOT NULL,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS  `#__js_inbox_junk` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `message_id` int(10) unsigned NOT NULL default '0',
  `user_id` int(10) unsigned NOT NULL default '0' COMMENT 'User which must see message_id message',
  `_read` datetime NOT NULL default '0000-00-00 00:00:00',
  `trash` tinyint(1) NOT NULL default '0',
  `flag` text NOT NULL,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS  `#__js_inbox_messages` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `subject` text NOT NULL,
  `body` text NOT NULL,
  `type_id` int(10) unsigned NOT NULL default '0',
  `ctime` datetime NOT NULL default '0000-00-00 00:00:00',
  `relation_type` varchar(45) NOT NULL default '' COMMENT 'relation with parent as replay or forward',
  `parent_id` int(10) unsigned NOT NULL default '0',
  `stime` datetime NOT NULL default '0000-00-00 00:00:00' COMMENT 'When user plan to send this message',
  `params` text NOT NULL,
  `attachments` text NOT NULL,
  `user_id` int(10) unsigned NOT NULL default '0' COMMENT 'Who is creater',
  `priority` tinyint(1) unsigned NOT NULL default '0',
  `mail_ident` text NOT NULL,
  `addresses` text NOT NULL,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS  `#__js_inbox_sent` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `user_id` int(10) unsigned NOT NULL default '0',
  `message_id` int(10) unsigned NOT NULL default '0',
  `trash` tinyint(1) NOT NULL default '0',
  `flag` text NOT NULL,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS  `#__js_inbox_types` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` text NOT NULL,
  `params` text NOT NULL,
  `published` tinyint(1) unsigned NOT NULL default '0',
  `can_choose` tinyint(1) unsigned NOT NULL default '0',
  `description` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `def` tinyint(1) unsigned NOT NULL default '0',
  `access` int(10) unsigned NOT NULL default '0',
  `def_folder_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS  `#__js_inbox_preset_assign` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `core_folder` text NOT NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `preset_id` int(10) unsigned NOT NULL default '0',
  `user_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS  `#__js_inbox_presets` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `user_id` int(10) unsigned NOT NULL default '0',
  `params` text NOT NULL,
  `title` text NOT NULL,
  `description` text NOT NULL,
  `global` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8;

REPLACE #__js_inbox_types VALUES ( 1, 'Message', 'resource_type_id=
allow_cc=1
allow_bcc=1
allow_reply=1
allow_forward=1
attachments=1
msg_body_editor=

', 1, 1, 'Default message type', 62, '2009-01-30 11:49:33', 1, 0, 0 );