<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyMessage by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('restricted');

jimport( 'joomla.application.component.view');

class InboxViewTypes extends JView
{
  function display( $tpl = null )
  {
      global $mainframe, $option;
  
      if( $this->getLayout() == 'form' ) {
          $this->_displayForm( $tpl );
          return;
      }
  
      $uri  =& JFactory::getURI();
      
      JToolBarHelper::title(   JText::_( 'Mighty Message Types' ), 'generic.png' );
      
      JToolBarHelper::makeDefault( 'makeDef' );
      JToolBarHelper::publishList();
      JToolBarHelper::unpublishList();
      JToolBarHelper::deleteList();
      JToolBarHelper::editListX();
      JToolBarHelper::addNewx();
      
      $bar = & JToolBar::getInstance('toolbar');
      $bar->addButtonPath(JPATH_COMPONENT_ADMINISTRATOR.DS.'library');
      $bar->appendButton( 'JSHelp',  'http://help.joomsuite.com/inbox/message_types.htm', 1000, 500 );
      
      $filter_order     = $mainframe->getUserStateFromRequest( $option.'types.filter_order',     'filter_order',     'name', 'cmd' );
      $filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'types.filter_order_Dir', 'filter_order_Dir', 'ASC',  'word' );
  
      $items = & $this->get('Types');
      
      $lists['order_Dir'] = $filter_order_Dir;
      $lists['order'] = $filter_order;
      
      $this->assignRef('user',       JFactory::getUser() );
      $this->assignRef('lists',       $lists );
      $this->assignRef('items',       $items );
      $this->assignRef('request_url', $uri->toString() );
      
      parent::display($tpl);
  }
    
  function _displayForm( $tpl = null )
  {
    global $mainframe, $option;

    jimport('joomla.html.pane');
    JHTML::_('behavior.tooltip');
    
    $user   =& JFactory::getUser();
    $model  =& $this->getModel();
    $uri    =& JFactory::getURI();
    
    $lists = array();

    $type = & $this->get( 'type' );
    
    $isNew = ( $type->id < 1 );

    JToolBarHelper::title( JText::_( $isNew ? 'Create Message Type' : 'Edit Message Type' ) );
    JToolBarHelper::save();
    JToolBarHelper::apply();
    if ( ! $isNew )  {
      JToolBarHelper::cancel();
    } else {
      JToolBarHelper::cancel( 'cancel', 'Close' );
    }
    
    if ( $model->isCheckedOut( $user->get( 'id' ) ) ) {
      $msg = JText::sprintf( 'DESCBEINGEDITTED', JText::_( 'The Type' ), $type->name );
      $mainframe->redirect( 'index.php?option='.$option.'&controller=types', $msg );
    }

    if ( !$isNew ) {
      $model->checkout( $user->get( 'id' ) );
    } else {
      $type->published = 1;
    }
    
    $slider = JPane::getInstance('sliders');
    
    $params = new JParameter( $type->params, JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jsinbox'.DS.'type.xml' );
    
    $lists['published']  = JHTML::_('select.booleanlist', 'published',  'class="inputbox"', $type->published );
    $lists['can_choose'] = JHTML::_('select.booleanlist', 'can_choose', 'class="inputbox"', $type->can_choose );
       
    $this->assignRef( 'item',        $type );
    $this->assignRef( 'lists',       $lists );
    $this->assignRef( 'params',      $params );
    $this->assignRef( 'slider',      $slider );
    $this->assignRef( 'request_url', $uri->toString() );
    parent::display( $tpl );
  }
}
?>