<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyMessage by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.model' );
jimport( 'joomla.utilities.date' );

JModel::addIncludePath( JPATH_BASE.DS.'components'.DS.'com_jsinbox'.DS.'models' );

JTable::addIncludePath( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jsinbox'.DS.'tables' );

if( !defined( 'JSPATH_INBOX_ADMIN' ) ) {
	define( 'JSPATH_INBOX_ADMIN', JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jsinbox' );
}
if( !defined( 'JSPATH_INBOX_SITE' ) ) {
	define( 'JSPATH_INBOX_SITE', JPATH_SITE.DS.'components'.DS.'com_jsinbox' );
}
require_once ( JSPATH_INBOX_ADMIN.DS.'controllers'.DS.'cnf.php' );

InboxControllerCnf::initialyze();

require_once ( JSPATH_INBOX_SITE.DS.'helpers'.DS.'registry.php' );

class JSInboxApi
{
	function renderMsgChain( $last_message )
	{
		$document = & JFactory::getDocument();
		$document->addStyleSheet( JURI::root().'components/com_jsinbox/css/toolbar.css' );
		$document->addStyleSheet( JURI::root().'components/com_jsinbox/css/main.css' );
		 
		$mInbox = &JModel::getInstance("Inbox", 'InboxModel');
		$msgChain = $mInbox->getMessageChain( $last_message );


		$result = "";
		foreach( $msgChain as $msg ) {
			$result .= JSInboxApi::_displayMessage( $msg );
		}
			
		ob_start();
		?>
        <script type="text/javascript">
		
		  function toggleMsgBody( msgIdent )
		  {
		    var msgDiv      = document.getElementById( 'jinbMsg_' + msgIdent );
		    var loadDiv     = document.getElementById( 'jinbLoad_' + msgIdent );
		    var bodyContDiv = document.getElementById( 'jinbBodyCont_' + msgIdent );
		    
		    if( msgDiv.style.display == "none" ) {
		      msgDiv.style.display = "block";
		    } else {
		      msgDiv.style.display = "none";
		    }
		    if( typeof bodyContDiv.jingLoaded == "undefined" || ! bodyContDiv.jingLoaded ) {
		      bodyContDiv.jingLoaded = true;
		    }
		  } 
        </script>

		<?php
		$result .= ob_get_clean();
		 
		return $result;
	}

	function _displayMessage( $msg )
	{
		$user = JFactory::getUser( $msg->get( "user_id" ) );
		$ctime = new JDate( $msg->get( "ctime" ) );

		$addressesTo = implode( ", ", $msg->getAddresses( 'to' ) );
		$addressesCC = implode( ", ", $msg->getAddresses( 'cc' ) );

		ob_start();

		?>
		<DIV align="right" id="me-inbox-toolbar-box">
			<div class="t">
				<div class="t">
				    <div class="t"></div>
				</div>
			</div>
			<div class="m" align="right">
			
			<table width="100%"
				onclick="toggleMsgBody('<?php echo $msg->get( "id" ); ?>');"
				class="chain_msg_title" cellspacing="0">
				<tr class="sectiontableentry2">
					<td align="left"><b><?php echo $user->get( "username" ); ?>:</b> <?php echo $msg->get( "subject" ) ?></td>
					<td width="20%"><?php echo $ctime->toFormat( INBOX_TIME_FORMAT ); ?></td>
				</tr>
			</table>
			
			<div class="chain_msg_body">
				<div id="jinbMsg_<?php echo $msg->get( "id" ); ?>"
					style="display: none; text-align: left;">
				<div id="jinbBodyCont_<?php echo $msg->get( "id" ); ?>">
					<table cellspacing="2">
						<tr>
							<td align="right" class="small"><?php echo JText::_( "From" ); ?>:</td>
							<td align="left"><b id="jinbFrom_<?php echo $msg->get( "id" ); ?>"><?php echo $user->username; ?></b></td>
						</tr>
						<tr>
							<td align="right" class="small"><?php echo JText::_( "To" ); ?>:</td>
							<td align="left" id="jinbTo_<?php echo $msg->get( "id" ); ?>"><?php echo $addressesTo; ?></td>
						</tr>
						<?php if( $addressesCC ) { ?>
						<tr style="display: none;"
							id="jinbCCCont_<?php echo $msg->get( "id" ); ?>">
							<td align="right" class="small"><?php echo JText::_( "CC" ); ?>:</td>
							<td align="left" id="jinbCC_<?php echo $msg->get( "id" ); ?>"><?php echo $addressesCC; ?></td>
						</tr>
						<?php } ?>
						<tr>
							<td align="right" class="small"><?php echo JText::_( "Subject" ); ?>:</td>
							<td align="left" id="jinbSubject_<?php echo $msg->get( "id" ); ?>"><?php echo $msg->get( "subject" ); ?></td>
						</tr>
						<tr>
							<td align="right" class="small"><?php echo JText::_( "Date" ); ?>:</td>
							<td align="left" id="jinbDate_<?php echo $msg->get( "id" ); ?>"><?php echo $ctime->toFormat( INBOX_TIME_FORMAT ); ?></td>
						</tr>
					</table>
					<br />
					<div id="jinbBody_<?php echo $msg->get( "id" ); ?>"	style="padding: 5px;" class="links_to_blank"><?php echo $msg->get( "body" ); ?></div>
				</div>
				</div>
			</div>
			
			</div>
			<div class="b">
				<div class="b">
				    <div class="b"></div>
				</div>
			</div>
		</DIV>
		<?php
	
		$result = ob_get_clean();
		return $result;
	}

	/*
     * This function render the message tree with roo in message with id = $first_message
     * 
     * @param int $first_message
     * @param int $uid_filter - if pass then message tree will contain only tallking between author of $first_message and user with id = $uid_filter
     * 
     * return html with message tree
     */
	
	function renderMessageTree( $first_message, $uid_filter = null )
	{
		$document = & JFactory::getDocument();
		$document->addStyleSheet( JURI::root().'components/com_jsinbox/css/toolbar.css' );
		$document->addStyleSheet( JURI::root().'components/com_jsinbox/css/main.css' );
		 
		$messageTree = JSInboxApi::_getMessageTree( $first_message, $uid_filter );
		 
		$tMessages = & JTable::getInstance( 'Messages', 'Table' );
		$tMessages->load( $first_message );
		if( $tMessages->get( "ctime" ) == "0000-00-00 00:00:00" ) {
			return "";
		}

		$fullMessageTree[] = array( "message" => $tMessages, "children" => $messageTree );
		 
		 
		$result = JSInboxApi::_renderBranch( $fullMessageTree );
		 
		ob_start();
		?>
	    <script type="text/javascript">
	    
	      function toggleMsgBody( msgIdent )
	      {
	        var msgDiv      = document.getElementById( 'jinbMsg_' + msgIdent );
	        var loadDiv     = document.getElementById( 'jinbLoad_' + msgIdent );
	        var bodyContDiv = document.getElementById( 'jinbBodyCont_' + msgIdent );
	        
	        if( msgDiv.style.display == "none" ) {
	          msgDiv.style.display = "block";
	        } else {
	          msgDiv.style.display = "none";
	        }
	        if( typeof bodyContDiv.jingLoaded == "undefined" || ! bodyContDiv.jingLoaded ) {
	          bodyContDiv.jingLoaded = true;
	        }
	      } 
	    </script>

		<?php
		$result .= ob_get_clean();
		 
		return $result;
	}

	function _renderBranch( $messageTree )
	{
		$result = "";
		foreach( $messageTree as $message ) {
			$result .= "<div style='padding-left:20px'>";
			$result .= JSInboxApi::_displayMessage( $message['message'] );
			$result .= JSInboxApi::_renderBranch( $message['children'] );
			$result .= "</div>";
		}
		return $result;
	}
	
	function _getMessageTree( $first_message, $uid_filter = null, $uid_filter2 = null )
	{
		$db = JFactory::getDBO();
		$result = array();

		if( !is_null( $uid_filter ) && is_null( $uid_filter2 ) ) {
			$tFirstMessage = & JTable::getInstance( 'Messages', 'Table' );
			$tFirstMessage->load( $first_message );
			
			$uid_filter2 = $tFirstMessage->get( "user_id" );
		}
		
		$db->setQuery( " SELECT id"
					."\n   FROM #__js_inbox_messages"
					."\n  WHERE parent_id = ".$first_message );
		$children = $db->loadResultArray();

		foreach( $children as $child_msg ) {
			 
			$tMessages = & JTable::getInstance( 'Messages', 'Table' );
			$tMessages->load( $child_msg );
			
			if( !is_null( $uid_filter ) ) {
				$found_author = false;
				$found_address = false;
				$addresses = $tMessages->getAddresses();
                
				if( $tMessages->get( "user_id" ) == $uid_filter || $tMessages->get( "user_id" ) == $uid_filter2 ) {
					$found_author = true;

					$needle_author = $tMessages->get( "user_id" );
					$needle_address = $tMessages->get( "user_id" ) == $uid_filter ? $uid_filter2 : $uid_filter;
					
					if(    isset( $addresses['sto_names'][$needle_address] )
	                    || isset( $addresses['to'][$needle_address] )
	                    || isset( $addresses['cc'][$needle_address] )
	                    || isset( $addresses['bcc'][$needle_address] ) ) {
	                    $found_address = true;
	                } else if( isset( $addresses['group_addresses'] ) ) {
						foreach( $addresses['group_addresses'] as $group_id => $users ) {
							foreach( $users as $user_id => $username ) {
								if( $user_id == $needle_address ) {
									$found_address = true;
								}
							}
						}
					}
				}
				
				if( ! $found_author || !$found_address ) {
					continue;
				}
			}
			
			$subchildren = JSInboxApi::_getMessageTree( $child_msg, $uid_filter, $uid_filter2 );
			$result[] = array( "message" => $tMessages, "children" => $subchildren );
		}

		return $result;
	}
}

?>
