<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyMessage by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined ( '_JEXEC' ) or die ();

jimport ( 'joomla.application.component.controller' );

class InboxControllerInbox extends JController {
	
	function __construct() {
		global $mainframe;
		
		parent::__construct ();
		$this->registerTask ( 'saveDraft', 'send' );
		$this->registerTask ( 'cancelDraft', 'cancelCompose' );
		$this->registerTask ( 'resend', 'compose' );
		$this->registerTask ( 'toTrashSingle', 'toTrash' );
	}
	
	function display() {
		if (! JRequest::getCmd ( 'view' )) {
			JRequest::setVar ( 'view', 'inbox' );
		}
		
		$ident = JRequest::getVar ( "iid" );
		
		if ($ident && class_exists ( "JSCommunityApi" )) {
			$user = JFactory::getUser ();
			
			$mInbox = & JModel::getInstance ( 'Inbox', 'InboxModel' );
			
			$message = $mInbox->getMessage ( $ident );
			
			$sender = & JFactory::getUser ( $message->user_from );
			
			$mFolders = & JModel::getInstance ( 'Options', 'InboxModel' );
			
			$user_options = $mFolders->getOptions ( $user );
			if ($user_options->get ( "recieve_message_read_alert" ) && ! intval ( $message->_read ) && $sender->id != $user->id) {
				jinbHelper::readMessageEvent ( $sender, $user, $message->subject );
			}
		}
		
		parent::display ();
	}
	
	function download() {
		$id = JRequest::getInt ( 'file' );
		
		$tMessage = & JTable::getInstance ( 'Messages', 'Table' );
		$tMessage->load ( $id );
		
		$user = JFactory::getUser ( $tMessage->get ( 'user_id' ) );
		
		$browser = $_SERVER ['HTTP_USER_AGENT'];
		
		if (ereg ( 'Opera(/| )([0-9].[0-9]{1,2})', $browser )) {
			$browser = 'OPERA';
		} else if (ereg ( 'MSIE ([0-9].[0-9]{1,2})', $browser )) {
			$browser = 'IE';
		} else if (ereg ( 'OmniWeb/([0-9].[0-9]{1,2})', $browser )) {
			$browser = 'OMNIWEB';
		} else if (ereg ( '(Konqueror/)(.*)', $browser )) {
			$browser = 'KONQUEROR';
		} else if (ereg ( 'Mozilla/([0-9].[0-9]{1,2})', $browser )) {
			$browser = 'MOZILLA';
		} else {
			$browser = 'OTHER';
		}
		
		$file_name = $id;
		
		$user_dir = str_replace ( str_replace ( "\\", "/", JPATH_ROOT . DS ), JURI::root (), INBOX_UPLOAD_FOLDER ) . "/" . $user->get ( "id" ) . "/" . "attachments";
		$server_dir = INBOX_UPLOAD_FOLDER . "/" . $user->get ( "id" ) . "/" . "attachments";
		
		$client_file = JPath::clean ( $user_dir . DS . $file_name );
		$server_file = $server_dir . DS . $file_name;
		
		//print basename( $tMessage->get( "attachments" ) ); 
		//print gmdate('D, d M Y H:i:s');exit;
		if (file_exists ( $server_file )) {
			header ( 'Content-Type: ' . (($browser == 'IE' || $browser == 'OPERA') ? 'application/octetstream' : 'application/octet-stream') );
			header ( 'Expires: ' . gmdate ( 'D, d M Y H:i:s' ) . ' GMT' );
			header ( 'Content-Transfer-Encoding: binary' );
			header ( 'Content-Length: ' . filesize ( $server_file ) );
			header ( "Content-Encoding: none" );
			if ($browser == 'IE') {
				header ( 'Content-Disposition: attachment; filename="' . basename ( $tMessage->get ( "attachments" ) ) . '"' );
				header ( 'Cache-Control: must-revalidate, post-check=0, pre-check=0' );
				header ( 'Pragma: public' );
			} else {
				header ( 'Content-Disposition: attachment; filename="' . basename ( $tMessage->get ( "attachments" ) ) . '"' );
				header ( 'Cache-Control: no-cache, must-revalidate' );
				header ( 'Pragma: no-cache' );
			}
			
			$this->readfile_chunked ( $server_file );
		} else {
			print JText::_ ( "File not found" );
		}
		exit ();
	}
	
	function readfile_chunked($filename, $retbytes = true) {
		error_reporting ( 0 );
		//ignore_user_abort(true);
		set_time_limit ( 0 );
		$chunksize = 1 * (1024 * 1024); // how many bytes per chunk
		$buffer = '';
		$cnt = 0;
		// $handle = fopen($filename, 'rb');
		$handle = fopen ( $filename, 'rb' );
		if ($handle === false) {
			echo "Cannot open file";
			exit ();
			return false;
		}
		while ( ! feof ( $handle ) ) {
			$buffer = @fread ( $handle, $chunksize );
			echo $buffer;
			if ($retbytes) {
				$cnt += strlen ( $buffer );
			}
		}
		$status = fclose ( $handle );
		if ($retbytes && $status) {
			return $cnt; // return num. bytes delivered like readfile() does.
		}
		return $status;
	}
	
	function read() {
		$cid = JRequest::getVar ( "cid" );
		if (is_array ( $cid ) && count ( $cid )) {
			JRequest::setVar ( "iid", $cid [0] );
		}
		
		JRequest::setVar ( 'view', 'read' );
		
		parent::display ();
	}
	
	function removeAttachment() {
		$tMessage = & JTable::getInstance ( 'Messages', 'Table' );
		$tMessage->load ( JRequest::getInt ( 'stored_msg_id' ) );
		
		$user_dir = INBOX_UPLOAD_FOLDER . DS . $tMessage->get ( "user_id" ) . DS . "attachments";
		JFile::delete ( $user_dir . DS . $tMessage->get ( "id" )/*."_".$tMessage->attachments*/ );
		
		$tMessage->set ( 'attachments', "" );
		$tMessage->store ();
		
		if (INBOX_PU_COMPOSE) {
			JRequest::setVar ( "tmpl", "component" );
		}
		
		$this->compose ();
	}
	
	function cancel() {
		global $mainframe, $option;
		
		$return = JRequest::getVar ( "return", "" );
		
		$lang = JRequest::getVar ( 'lang' ) ? "&lang=" . JRequest::getVar ( 'lang' ) : "";
		$Itemid = JRequest::getVar ( 'Itemid' ) ? "&Itemid=" . JRequest::getVar ( 'Itemid' ) : "";
		
		$cfolder = $mainframe->getUserState ( $option . '.cfolder' );
		$folder = $mainframe->getUserState ( $option . '.folder' );
		
		$urlFolder = $folder ? "&folder=" . $folder : "&cfolder=" . $cfolder;
		
		$redirect_url = 'index.php?option=com_jsinbox' . $urlFolder . $Itemid . $lang;
		
		if ($return) {
			$redirect_url = base64_decode ( $return );
		}
		
		$this->assignRedirect ( $redirect_url, "", INBOX_PU_COMPOSE );
	}
	
	function cancelRead() {
		global $mainframe, $option;
		
		$lang = JRequest::getVar ( 'lang' ) ? "&lang=" . JRequest::getVar ( 'lang' ) : "";
		$Itemid = JRequest::getVar ( 'Itemid' ) ? "&Itemid=" . JRequest::getVar ( 'Itemid' ) : "";
		
		$cfolder = $mainframe->getUserState ( $option . '.cfolder' );
		$folder = $mainframe->getUserState ( $option . '.folder' );
		
		$urlFolder = $folder ? "&folder=" . $folder : "&cfolder=" . $cfolder;
		
		$redirect_url = 'index.php?option=com_jsinbox' . $urlFolder . $Itemid . $lang;
		
		$this->assignRedirect ( $redirect_url, "", INBOX_PU_READ_MSG );
	}
	
	function cancelCompose() {
		global $mainframe, $option;
		$tMessage = & JTable::getInstance ( 'Messages', 'Table' );
		
		if (JRequest::getInt ( 'stored_msg_id' ) && JRequest::getWord ( 'task' ) == 'cancelCompose') {
			$tMessage->load ( JRequest::getInt ( 'stored_msg_id' ) );
			
			if ($tMessage->attachments) {
				$user_dir = INBOX_UPLOAD_FOLDER . DS . $tMessage->get ( "user_id" ) . DS . "attachments";
				JFile::delete ( $user_dir . DS . $tMessage->get ( "id" )/*."_".$tMessage->attachments*/ );
			}
			
			$tMessage->delete ();
		}
		
		$lang = JRequest::getVar ( 'lang' ) ? "&lang=" . JRequest::getVar ( 'lang' ) : "";
		$Itemid = JRequest::getVar ( 'Itemid' ) ? "&Itemid=" . JRequest::getVar ( 'Itemid' ) : "";
		
		$cfolder = $mainframe->getUserState ( $option . '.cfolder' );
		$folder = $mainframe->getUserState ( $option . '.folder' );
		
		$urlFolder = $folder ? "&folder=" . $folder : "&cfolder=" . $cfolder;
		
		$redirect_url = 'index.php?option=com_jsinbox' . $urlFolder . $Itemid . $lang;
		
		$this->assignRedirect ( $redirect_url, "", (JRequest::getVar ( "tmpl" ) == "component" ? 1 : 0) /*INBOX_PU_COMPOSE*/ );
	}
	
	function cleanTrash() {
		global $mainframe, $option;
		
		$mInbox = & JModel::getInstance ( 'Inbox', 'InboxModel' );
		
		if ($mInbox->cleanTrash ()) {
			$msg = JText::_ ( 'Trash cleaned successfuly' );
		} else {
			$msg = JText::_ ( 'Trash clean failed' ) . " <br /> " . $mInbox->getError ();
		}
		
		$itemid = JRequest::getInt ( "Itemid" );
		$mainframe->redirect ( 'index.php?option=com_jsinbox&cfolder=trash' . ($itemid ? "&Itemid=" . $itemid : ""), $msg );
	}
	
	function delete() {
		global $mainframe, $option;
		
		$cid = JRequest::getVar ( "cid" );
		
		$mInbox = & JModel::getInstance ( 'Inbox', 'InboxModel' );
		
		if ($mInbox->delete ( $cid )) {
			$msg = JText::_ ( 'Messages deleted successfuly' );
		} else {
			$msg = JText::_ ( 'Messages delete failed' ) . " <br /> " . $mInbox->getError ();
		}
		
		$itemid = JRequest::getInt ( "Itemid" );
		$mainframe->redirect ( 'index.php?option=com_jsinbox&cfolder=trash' . ($itemid ? "&Itemid=" . $itemid : ""), $msg );
	}
	
	function restore() {
		global $mainframe, $option;
		
		$cid = JRequest::getVar ( "cid" );
		
		$mInbox = & JModel::getInstance ( 'Inbox', 'InboxModel' );
		
		if ($mInbox->restore ( $cid )) {
			$msg = JText::_ ( 'Messages restored successfuly' );
		} else {
			$msg = JText::_ ( 'Messages restore failed' ) . " <br /> " . $mInbox->getError ();
		}
		
		$itemid = JRequest::getInt ( "Itemid" );
		$mainframe->redirect ( 'index.php?option=com_jsinbox&cfolder=trash' . ($itemid ? "&Itemid=" . $itemid : ""), $msg );
	}
	
	function toTrash() {
		global $mainframe, $option;
		
		$task = JRequest::getVar ( "task" );
		$cid = JRequest::getVar ( "cid" );
		
		$mInbox = & JModel::getInstance ( 'Inbox', 'InboxModel' );
		if ($mInbox->toTrash ( $cid )) {
			$msg = JText::_ ( 'Messages moved to trash successfuly' );
		} else {
			$msg = JText::_ ( 'Messages moved to trash failed' ) . " <br /> " . $mInbox->getError ();
		}
		
		$itemid = JRequest::getInt ( "Itemid" );
		
		$cfolder = $mainframe->getUserState ( $option . '.cfolder' );
		$folder = $mainframe->getUserState ( $option . '.folder' );
		
		$urlFolder = $folder ? "&folder=" . $folder : "&cfolder=" . $cfolder;
		/*$mainframe->redirect( 'index.php?option=com_jsinbox'.$urlFolder.( $itemid ? "&Itemid=".$itemid : "" ), $msg );*/
		
		$this->assignRedirect ( 'index.php?option=com_jsinbox' . $urlFolder . ($itemid ? "&Itemid=" . $itemid : ""), $msg, INBOX_PU_READ_MSG );
	}
	
	function compose() {
		global $mainframe;
		if (JRequest::getVar ( "task" ) == "resend") {
			$mInbox = & JModel::getInstance ( 'Inbox', 'InboxModel' );
			$mTypes = & JModel::getInstance ( 'Types', 'InboxModel' );
			
			$ident = JRequest::getVar ( "cid" );
			
			$message = $mInbox->getMessage ( $ident [0] );
			
			$mTypes->setId ( $message->type_id );
			$tType = $mTypes->getType ();
			
			$type_params = new JParameter ( $tType->get ( 'params' ) );
			
			if ((JRequest::getVar ( "context" ) == "reply" && ! $type_params->get ( "allow_reply" )) || (JRequest::getVar ( "context" ) == "reply_all" && ! $type_params->get ( "allow_reply" )) || (JRequest::getVar ( "context" ) == "forward" && ! $type_params->get ( "allow_forward" ))) {
				
				$msg = JText::_ ( "This message can`t be resent" );
				
				$cfolder = $mainframe->getUserState ( $option . '.cfolder' );
				$folder = $mainframe->getUserState ( $option . '.folder' );
				
				$urlFolder = $folder ? "&folder=" . $folder : "&cfolder=" . $cfolder;
				
				$this->assignRedirect ( 'index.php?option=com_jsinbox' . $urlFolder . ($itemid ? "&Itemid=" . $itemid : ""), $msg, INBOX_PU_READ_MSG );
				return;
			}
		}
		
		JRequest::setVar ( 'view', 'compose' );
		parent::display ();
	}
	
	function move() {
		global $mainframe, $option;
		
		$mInbox = & JModel::getInstance ( 'Inbox', 'InboxModel' );
		
		if ($mInbox->move ( JRequest::get ( 'post' ) )) {
			$msg = JText::_ ( 'Messages moved success' );
		} else {
			$msg = JText::_ ( 'Messages moved failed' ) . " <br /> " . $mInbox->getError ();
		}
		
		$itemid = JRequest::getInt ( "Itemid" );
		
		$urlFolder = JRequest::getVar ( 'from' ) ? "&folder=" . JRequest::getVar ( 'from' ) : "&cfolder=" . JRequest::getVar ( 'cfrom', 'inbox' );
		//$mainframe->redirect( 'index.php?option=com_jsinbox'.$urlFolder.( $itemid ? "&Itemid=".$itemid : "" ), $msg );
		$this->assignRedirect ( 'index.php?option=com_jsinbox' . $urlFolder . ($itemid ? "&Itemid=" . $itemid : ""), $msg, INBOX_PU_READ_MSG );
	}
	
	function send() {
		global $mainframe, $option;
		
		$inboxSender = new inboxSender ( );
		$inboxSender->init ();
		
		$sent_is_success = $inboxSender->sendMsg ();
		
		$return = JRequest::getVar ( "return", "" );
		
		if ($return) {
			
			$return = base64_decode ( $return );
			
			if ($sent_is_success) {
				$this->assignRedirect ( $return, $inboxSender->redirect_msg, 0 );
			
			} else {
				JError::raiseWarning ( 305, $inboxSender->redirect_msg );
				
				$this->assignRedirect ( $return, $inboxSender->redirect_msg, 0 );
			}
			return;
		}
		
		if ($sent_is_success) {
			if (class_exists ( "JSCommunityApi" )) {
				$inboxSender->setEvents ();
			}
			
			$lang = JRequest::getVar ( 'lang' ) ? "&lang=" . JRequest::getVar ( 'lang' ) : "";
			$Itemid = JRequest::getVar ( 'Itemid' ) ? "&Itemid=" . JRequest::getVar ( 'Itemid' ) : "";
			
			$cfolder = $mainframe->getUserState ( $option . '.cfolder' );
			$folder = $mainframe->getUserState ( $option . '.folder' );
			
			$urlFolder = $folder ? "&folder=" . $folder : "&cfolder=" . $cfolder;
			
			$redirect_url = 'index.php?option=com_jsinbox' . $urlFolder . $Itemid . $lang;
			
			$this->assignRedirect ( $redirect_url, $inboxSender->redirect_msg, (JRequest::getVar ( "tmpl" ) == "component" ? 1 : 0) );
		
		} else {
			JError::raiseWarning ( 305, $inboxSender->redirect_msg );
			
			if (INBOX_PU_COMPOSE) {
				JRequest::setVar ( "tmpl", "component" );
			}
			
			$this->compose ();
		}
	}
	
	function assignRedirect($redirect_url, $msg = "", $pu) {
		global $mainframe;
		$return = '&return=' . base64_encode ( $redirect_url );
		
		$url = JURI::base () . "index.php?option=com_jsinbox&task=jinbRedirect&msg=" . base64_encode ( $msg ) . $return;
		
		if ($pu) {
			print '<script type="text/javascript">' . "parent.location.href='" . $url . "';" . 'parent.Shadowbox.close();' . '</script>';
		} else {
			$mainframe->redirect ( $redirect_url, $msg );
		}
	}
	
	function jinbRedirect() {
		global $mainframe;
		$redirect = base64_decode ( JRequest::getVar ( 'return' ) );
		$msg = base64_decode ( JRequest::getVar ( 'msg' ) );
		$mainframe->redirect ( $redirect, $msg );
	}
}

class inboxSender {
	var $task = null;
	
	var $user = null;
	
	var $mInbox = null;
	var $mOptions = null;
	var $mTypes = null;
	
	var $post = null;
	
	var $additions = null;
	
	var $msg_type_id = null;
	
	var $addresses = null;
	
	var $group_addresses = null;
	
	var $error = false;
	
	var $redirect_msg = array ();
	
	var $msgType = null;
	
	var $resourseFieldsHelper = null;
	
	var $assign_message_problems = "";
	
	var $sender_options = null;
	
	function setEvents() {
		$mFolders = & JModel::getInstance ( 'Options', 'InboxModel' );
		foreach ( $this->addresses ['find'] as $field ) {
			foreach ( $field as $user_to ) {
				$user_options = $mFolders->getOptions ( $user_to );
				if ($user_options->get ( "recieve_new_message_alert" )) {
					//print_r($user_to); exit;
					jinbHelper::newMessageEvent ( $this->user, $user_to, $this->mInbox->stored_message );
				}
			}
		}
	}
	
	function init() {
		$this->task = JRequest::getVar ( 'task' );
		
		$this->user = JFactory::getUser ();
		$this->mInbox = & JModel::getInstance ( 'Inbox', 'InboxModel' );
		$this->mOptions = & JModel::getInstance ( 'Options', 'InboxModel' );
		$this->mTypes = & JModel::getInstance ( 'Types', 'InboxModel' );
		
		$this->post = JRequest::get ( "post", 2 );
		
		$this->additions = JRequest::getVar ( "additions", array () );
		
		$this->msg_type_id = $this->post ['type_id'];
		
		$this->post ["user_id"] = $this->user->get ( "id" );
		
		$this->addresses = array ('sto' => JRequest::getVar ( "sto", array () ), 'to' => JRequest::getVar ( "to", "" ), 'cc' => JRequest::getVar ( "cc", "" ), 'bcc' => JRequest::getVar ( "bcc", "" ) );
		
		$this->group_addresses = JRequest::getVar ( "group_addresses", array () );
		
		$this->mTypes->setId ( $this->msg_type_id );
		$this->msgType = $this->mTypes->getType ();
		$this->msgType->params = new JParameter ( $this->msgType->params );
		
		$this->message_body = $this->post ["body"];
		
		if (strip_tags ( $this->message_body ) == $this->message_body) {
			$this->message_body = nl2br ( $this->message_body );
		}
		
		$this->sender_options = $this->mOptions->getOptions ( $this->user );
	}
	
	function prepareAddresses() {
		$this->addresses = jinbHelper::parseAddresses ( $this->addresses );
		
		$this->group_addresses = $this->mInbox->initGroupAddresses ( $this->group_addresses );
		
		$this->mOptions->setOptionsToAddressList ( $this->addresses ['find'], $this->group_addresses );
		
		if ($this->task == 'send') {
			$this->post ["addresses"] = jinbHelper::addressesToUsernames ( $this->addresses ['find'] );
			if (count ( $this->group_addresses )) {
				$this->post ["addresses"] = array_merge ( $this->post ["addresses"], array ("group_addresses" => jinbHelper::groupAddressesToUsernames ( $this->group_addresses ) ) );
			}
		} else {
			$this->post ["addresses"] = array_merge_recursive ( jinbHelper::addressesToUsernames ( $this->addresses ['find'] ), $this->addresses ['unknown'] );
			if (count ( $this->group_addresses )) {
				$this->post ["addresses"] = array_merge ( $this->post ["addresses"], array ("group_addresses" => jinbHelper::groupAddressesToUsernames ( $this->group_addresses ) ) );
			}
		}
	}
	
	function mainCheck() {
		if ($this->task == 'send') {
			if (! $this->post ['subject']) {
				$this->redirect_msg [] = JText::_ ( 'Subject is empty' );
				$this->error = true;
			}
			if (! trim ( $this->post ['to'] ) && ! count ( JRequest::getVar ( "sto", array () ) ) && ! count ( JRequest::getVar ( "group_addresses", array () ) )) {
				$this->redirect_msg [] = JText::_ ( 'Field to is empty' );
				$this->error = true;
			}
			if (! $this->post ['body']) {
				$this->redirect_msg [] = JText::_ ( 'Message body is empty' );
				$this->error = true;
			}
			if (INBOX_MAX_RECIPIENTS) {
				if (isset ( $this->post ['to'] ) && count ( explode ( ",", $this->post ['to'] ) ) > INBOX_MAX_RECIPIENTS) {
					$this->redirect_msg [] = JText::_ ( 'There are too many addresses in "To" field' );
					$this->error = true;
				}
				if (isset ( $this->post ['cc'] ) && count ( explode ( ",", $this->post ['cc'] ) ) > INBOX_MAX_RECIPIENTS) {
					$this->redirect_msg [] = JText::_ ( 'There are too many addresses in "CC" field' );
					$this->error = true;
				}
				if (isset ( $this->post ['bcc'] ) && count ( explode ( ",", $this->post ['bcc'] ) ) > INBOX_MAX_RECIPIENTS) {
					$this->redirect_msg [] = JText::_ ( 'There are too many addresses in "BCC" field' );
					$this->error = true;
				}
			}
		
			if (class_exists ( "JSCommunityApi" )) {
				$comm_params = JSCommunityApiExtern::getCommunityParams();
				$allow_groups = $comm_params->get('groups::allow_send_to_all_groups');
				if(!is_array($allow_groups))
					settype($allow_groups, 'array');
				
				if (isset ( $this->post ["addresses"] ["group_addresses"] ) && count ( $this->post ["addresses"] ["group_addresses"] )) {
					$userGroupParty = JSCommunityApiExtern::getUserGroupParty ( $this->user->get ( "id" ) );
					foreach ( $this->post ["addresses"] ["group_addresses"] as $group_id => $user_list ) {
						$found = false;
						foreach ( $userGroupParty as $status => $groups ) {
							foreach ( $groups as $group ) {
								if ($group->id == $group_id || in_array($this->user->get ( "gid" ), $allow_groups)) {
									$found = true;
								}
							}
						}
						if (! $found) {
							$faild_group = JSCommunityApiExtern::getGroup ( $group_id );
							$this->redirect_msg [] = JText::sprintf ( 'You don`t have enough rights for sent message to group %s', $faild_group->title );
							$this->error = true;
						}
					}
				}
			}
		}
	}
	
	function resourceFieldsProcessing() {
		$this->resourseFieldsHelper = new jinbResourceFieldHelper ( );
		$this->resourseFieldsHelper->init ( $this->msgType );
		
		if (!$this->resourseFieldsHelper->fieldsValueProcessing ()) {
			$this->error = $this->resourseFieldsHelper->error;

			return false;
		}
		
		return true;
	}
	
	function checkAddresses() {
		if ($this->task == 'send' && isset ( $this->addresses ['unknown'] ) && count ( $this->addresses ['unknown'] )) {
			$this->redirect_msg [] = jinbHelper::getUnknownAddressesErrorMsg ( $this->addresses ['unknown'] );
			$this->error = true;
		}
	}
	
	function validateAttachments() {
		$ext = strtolower ( substr ( $_FILES ['attachments'] ['name'], strrpos ( $_FILES ['attachments'] ['name'], '.' ) + 1 ) );
		$exts = explode ( ",", str_replace ( array (" ", "\n", "\r" ), "", INBOX_ATTACHMENT_FORMATS ) );
		
		if (! in_array ( $ext, $exts )) {
			$this->redirect_msg [] = JText::_ ( "File is not apropriate format" );
			$this->error = true;
			return false;
		}
		if (INBOX_ATTACHMENT_MAX_SIZE && INBOX_ATTACHMENT_MAX_SIZE < ($_FILES ['attachments'] ['size'] / 1024)) {
			$this->redirect_msg [] = JText::_ ( "File size exceed allowed" );
			$this->error = true;
			return false;
		} else {
			$this->post ['attachments'] = $_FILES ['attachments'] ['name'];
			return true;
		}
	}
	
	function storeMessage() {
		if (! $id = $this->mInbox->storeMessage ( $this->post, JRequest::getVar ( "stored_msg_id" ) )) {
			$this->redirect_msg [] = JText::_ ( 'Error sending message:<br />' . $this->mInbox->getError () );
			$this->error = true;
		}
		return $id;
	}
	
	function uploadAttachments() {
		if ($this->post ["attachments"]) {
			$user_dir = INBOX_UPLOAD_FOLDER . DS . $this->user->get ( "id" ) . DS . "attachments";
			
			if (! JFolder::exists ( $user_dir )) {
				JFolder::create ( $user_dir );
			}
			
			JFile::upload ( $_FILES ['attachments'] ['tmp_name'], $user_dir . DS . $this->mInbox->stored_message->get ( "id" ) );
		}
	}
	
	function buildMsgBody() {
		if (count ( $this->additions )) {
			$additions_text = jinbHelper::renderAdditions ( $this->additions );
			$this->message_body = $additions_text . $this->message_body;
			$this->mInbox->stored_message->set ( "body", $this->message_body );
		}
		
		if ($this->msgType->params->get ( "resource_type_id" )) {
			$this->resourseFieldsHelper->joinFieldsToMessageBody ( $this->message_body );
			$this->mInbox->stored_message->set ( "body", $this->message_body );
		}
		
	/*$signature = $this->sender_options->get( 'signature' );
    if( $signature ) {
      $this->message_body .= '<br />'.nl2br( $signature );
      $this->mInbox->stored_message->set( "body", $this->message_body );
    }*/
	}
	
	function saveInDraft() {
		$message_progress = $this->mInbox->getMessageProgress ( $this->user->get ( "id" ) );
		if (INBOX_MAX_STORING_MSG && ($message_progress ['count'] < $message_progress ['max_count']) && ! $this->mInbox->assignToDraft ( $this->mInbox->stored_message )) {
			$this->redirect_msg [] = JText::_ ( 'Error saving message:<br />' . $this->mInbox->getError () );
			$this->error = true;
		}
	}
	
	function assignMsgToUsers() {
		if (! $this->mInbox->assignMessageToUsers ( $this->mInbox->stored_message, $this->addresses ['find'], $this->group_addresses, $this->assign_message_problems )) {
			$this->redirect_msg [] = JText::_ ( 'Error sending message:<br />' . $this->mInbox->getError () );
			$this->error = true;
		}
	}
	
	function saveInSent() {
		$message_progress = $this->mInbox->getMessageProgress ( $this->user->get ( "id" ) );
		
		if (INBOX_MAX_STORING_MSG && ($message_progress ['count'] < $message_progress ['max_count'])) {
			$this->mInbox->storeMessageInSent ( $this->user->get ( "id" ), $this->mInbox->stored_message->get ( 'id' ) );
		}
	}
	
	function sendMsg() {
		$this->prepareAddresses ();
		$this->mainCheck ();
		
		if ($this->msgType->params->get ( "resource_type_id" )) {
			if (!$this->resourceFieldsProcessing ()) 
			{
				$this->redirect_msg = $this->error;
				return false;
			}
		}
		
		$this->checkAddresses ();
		
		$upload_attachment = false;
		if (isset ( $_FILES ['attachments'] ['name'] ) && $_FILES ['attachments'] ['name']) {
			$this->post ['attachments'] = "";
			$upload_attachment = $this->validateAttachments ();
		}
		
		$this->storeMessage ();
		
		if ($upload_attachment) {
			$this->uploadAttachments ();
		}
		
		if (! $this->error) {
			$this->buildMsgBody ();
			
			if ($this->task == 'saveDraft') {
				$this->saveInDraft ();
			}
			
			if ($this->task == 'send') {
				$this->assignMsgToUsers ();
			}
			
			if ($this->task == 'send' && JRequest::getVar ( "save_in_sent" )) {
				$this->saveInSent ();
			}
			
			if ($this->error) {
				$this->mInbox->stored_message->set ( "body", $this->post ["body"] );
			}
		}
		
		if ($this->task == 'send') {
			JRequest::setVar ( "stored_msg_id", $this->mInbox->stored_message->get ( "id" ) );
		}
		
		if ($this->error) {
			$this->redirect_msg = implode ( "<br />", $this->redirect_msg );
			return false;
		}
		
		if ($this->msgType->params->get ( "resource_type_id" ) || count ( $this->additions ) || $this->sender_options->get ( 'signature' )) {
			$this->mInbox->stored_message->store ();
		}
		
		$this->redirect_msg = $this->task == 'send' ? JText::_ ( "Message sent successfuly" ) : JText::_ ( "Message saved successfuly" );
		if ($this->assign_message_problems) {
			$this->redirect_msg .= '<br />' . $this->assign_message_problems;
		}
		
		return true;
	}
}
