<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyMessage by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

class InboxControllerPresets extends JController
{

  function __construct()
  {
    global $mainframe;
	  
    parent::__construct ();
    $this->registerTask( 'apply',      'save' );
    $this->registerTask( 'newPreset',  'edit' );
    $this->registerTask( 'editPreset', 'edit' );
  }
  
  function display() 
  {
    if ( ! JRequest::getCmd( 'view' ) ) {
      JRequest::setVar( 'view', 'presets' );
    }
    parent::display();
  }
  
  function cancel()
  {
    global $mainframe;
    
    $cfolder  = $mainframe->getUserStateFromRequest( $option.'.cfolder', 'cfolder', '',  'word' );
    $folder   = $mainframe->getUserStateFromRequest( $option.'.folder',  'folder',  '0', 'int' );
    
    $mainframe->redirect( 'index.php?option=com_jsinbox'.($folder ? "&folder=".$folder : "" ).($cfolder ? "&cfolder=".$cfolder : "" ) );
  }
  
  function remove()
  {
    global $mainframe, $option;
    
    $cid = JRequest::getVar( "cid" );
    
    $mPresets = & JModel::getInstance( 'Presets', 'InboxModel' );
    
    if( $mPresets->remove( $cid ) ) {
      $msg = JText::_( 'View deleted successfuly' );
    } else {
      $msg = JText::_( 'View delete failed' )." <br /> ".$mPresets->getError();
    }
    
    $tmpl = JRequest::getWord( "tmpl", "" );
    $mainframe->redirect( 'index.php?option=com_jsinbox&controller=presets'.( $tmpl ? "&tmpl=".$tmpl : "" ), $msg );
  }
  
  function edit()
  {
    JRequest::setVar( 'view',   'presets' );
    JRequest::setVar( 'layout', 'form' );
    
    parent::display();
  }
  
  function cancelEdit()
  {
    global $mainframe;
    $tmpl = JRequest::getWord( "tmpl", "" );
    $mainframe->redirect( 'index.php?option=com_jsinbox&controller=presets'.( $tmpl ? "&tmpl=".$tmpl : "" ) );
  }
  
  function save()
  {
    global $mainframe, $option;
    
    $task   = JRequest::getWord( 'task' );
    
    $cfolder  = $mainframe->getUserStateFromRequest( $option.'.cfolder', 'cfolder', '',  'word' );
    $folder   = $mainframe->getUserStateFromRequest( $option.'.folder',  'folder',  '0', 'int' );
    
    $mPresets = & JModel::getInstance( 'Presets', 'InboxModel' );
    
    $storedPreset = $mPresets->store( JRequest::get( 'post' ) );
    
    if( $storedPreset ) {
      if( JRequest::getInt( 'id' ) ) {
        $msg = JText::_( 'View saved successfuly' );
      } else {
        $msg = JText::_( 'View created successfuly' );
      }
      
      $mainframe->enqueueMessage( $msg );
      
      if( $task == "apply" ) {
        JRequest::setVar( 'id', $storedPreset->get('id') );
        $this->edit();
        return;
      } else {
        $tmpl = JRequest::getWord( "tmpl", "" );
        $mainframe->redirect( 'index.php?option=com_jsinbox&controller=presets'.( $tmpl ? "&tmpl=".$tmpl : "" ) );
      }
    } else {
      if( JRequest::getInt( 'id' ) ) {
        $msg = JText::_( 'Error save view' );
      } else {
        $msg = JText::_( 'Error create view' );
      }
      
      JError::raiseWarning( 301, $msg.' '.$mPresets->getError() );
      
      $this->edit();
    }
  }
}
?>
