<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyMessage by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined ( '_JEXEC' ) or die ( 'Restricted access' );
  class JinbRegistry extends JRegistry {
  function loadJinbXML($data, $namespace = null)
  {
    $handler =& JRegistryFormat::getInstance('JinbXML');

    if ($namespace == null) {
      $namespace = $this->_defaultNameSpace;
    }

    if (!isset($this->_registry[$namespace])) {
      $this->makeNameSpace($namespace);
      $this->_registry[$namespace]['data'] = $handler->stringToObject( $data );
    } else {
       $ns = $handler->stringToObject($data);

       foreach (get_object_vars($ns) as $k => $v) {
        $this->_registry[$namespace]['data']->$k = $v;
      }
    }

    return true;
  }
}

class JRegistryFormatJinbXML extends JRegistryFormat {

  function stringToObject( $data ) {
    $result = new stdClass();
    
    $xml = & JFactory::getXMLParser('Simple');
    $xml->loadString( $data );
    
    if ( !is_object($xml->document) || $xml->document->name() != "info" ) {
      return $result;
    }
    if( isset( $xml->document->entry ) ) {
      foreach( $xml->document->entry as $entry ) {
        $result->{$entry->attributes('name')} = $entry->data();
      }
    }
    if( isset( $xml->document->object ) ) {
      foreach( $xml->document->object as $object ) {
        $result->{$object->attributes('name')} = $this->_parseXMLGroup( $object );
      }
    }
    if( isset( $xml->document->array ) ) {
      foreach( $xml->document->array as $array ) {
        $result->{$array->attributes('name')} = $this->_parseXMLGroup( $array );
      }
    }
    
    return $result;
  }

  function _parseXMLGroup( & $xmlNode )
  {
    if( $xmlNode->name() == 'object') {
      $result = new stdClass();
      if( isset( $xmlNode->entry ) ) {
        foreach( $xmlNode->entry as $entry ) {
          $result->{$entry->attributes('name')} = $entry->data();
        }
      }
      if( isset( $xmlNode->object ) ) {
        foreach( $xmlNode->object as $object ) {
          $result->{$object->attributes('name')} = $this->_parseXMLGroup( $object );
        }
      }
      if( isset( $xmlNode->array ) ) {
        foreach( $xmlNode->array as $array ) {
          $result->{$array->attributes('name')} = $this->_parseXMLGroup( $array );
        }
      }
    } else {
      $result = array();
      if( isset( $xmlNode->entry ) ) {
        foreach( $xmlNode->entry as $entry ) {
          $result[$entry->attributes('name')] = $entry->data();
        }
      }
      if( isset( $xmlNode->object ) ) {
        foreach( $xmlNode->object as $object ) {
          $result[$object->attributes('name')] = $this->_parseXMLGroup( $object );
        }
      }
      if( isset( $xmlNode->array ) ) {
        foreach( $xmlNode->array as $array ) {
          $result[$array->attributes('name')] = $this->_parseXMLGroup( $array );
        }
      }
    }
    
    return $result;
  }
  
  function objectToString( &$object, $params = null )
  {
  	
    $heading = "<?xml version=\"1.0\" encoding=\"utf-8\"?>";

    $xml = & JFactory::getXMLParser('Simple');
    
    $xml->loadString( $heading."<info></info>" );
    
    foreach ( get_object_vars( $object ) as $key => $item ) {
        
      if ( is_object( $item ) || is_array( $item ) ) {
        
        $name = ( is_object($item)? "object" : "array" );
        
        $xml->document->addChild( $name, array( 'name' => $key ) );
        $num = count($xml->document->_children);
        $this->_buildNewXMLLevel( $xml->document->_children[( $num-1 )], $item );
      } else {
        $xml->document->addChild( 'entry', array( 'name' => $key ) );
        $num = count($xml->document->_children);
        $xml->document->_children[($num-1)]->setData( $item );
      }
    }
    
    $result = $heading.$xml->document->toString();
    return $result;
  }

  function _buildNewXMLLevel( & $parent, & $object )
  {
    if( is_object( $object ) ) {
      $entries = get_object_vars( $object );
    } else {
      $entries = $object;
    }
    
    foreach ( $entries as $key => $item ) {
      if ( is_object( $item )  || is_array( $item ) ) {
        $name = ( is_object( $item ) ? "object" : "array" );
        
        $parent->addChild( $name, array( 'name' => $key ) );
        $num = count( $parent->_children );
        $this->_buildNewXMLLevel( $parent->_children[( $num-1 )], $item );
      } else {
        $parent->addChild( 'entry', array( 'name' => $key ) );
        $num = count( $parent->_children );
        $parent->_children[( $num - 1 )]->setData( $item );
      }
    }
  }
}
?>