<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyMessage by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined ( '_JEXEC' ) or die ( 'Restricted access' );
class JINBToolBar extends JToolBar {
	function jcToolBar($name) {
		parent::__construct ( $name );
	}
	
	function render() {
		JHTML::_ ( 'behavior.mootools' );
		
		return parent::render ();
	}
	
	function sendMessage() {
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: void(0); inbSendForm( 'send' );\" class=\"toolbar\">" . "<span class=\"icon-32-send\" type=\"Standard\">" . "</span>" . JText::_ ( 'Send' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'sendMessage' );
	}
	
	function saveInDraft() {
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: void(0); inbSendForm( 'saveDraft' );\" class=\"toolbar\">" . "<span class=\"icon-32-save\" type=\"Standard\">" . "</span>" . JText::_ ( 'Save' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'saveInDraft' );
	}
	
	function apply() {
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: void(0); inbSendForm( 'apply' );\" class=\"toolbar\">" . "<span class=\"icon-32-apply\" type=\"Standard\">" . "</span>" . JText::_ ( 'Apply' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'apply' );
	}
	
	function save() {
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: void(0);  inbSendForm( 'save' );\" class=\"toolbar\">" . "<span class=\"icon-32-save\" type=\"Standard\">" . "</span>" . JText::_ ( 'Save' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'save' );
	}
	
	function cancelCompose($task) {
		$html = "<a href=\"javascript:inbSendForm( '" . $task . "' );\" class=\"toolbar\">" . "<span class=\"icon-32-cancel\" type=\"Standard\">" . "</span>" . JText::_ ( 'Cancel' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'cancel' );
	}
	
	function cancelOptions() {
		if (INBOX_PU_USER_OPTIONS && JRequest::getVar ( "tmpl" ) == "component") {
			$onClick = "parent.Shadowbox.close();";
		} else {
			$onClick = "inbSendForm( 'cancel' );";
		}
		
		$html = "<a href=\"javascript:" . $onClick . "\" class=\"toolbar\">" . "<span class=\"icon-32-cancel\" type=\"Standard\">" . "</span>" . JText::_ ( 'Cancel' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'cancel' );
	}
	
	function cancelFolder() {
		if (INBOX_PU_FOLDER && JRequest::getVar ( 'tmpl' ) == 'component') {
			$onClick = "parent.Shadowbox.close();";
		} else {
			$onClick = "inbSendForm( 'cancel' );";
		}
		
		$html = "<a href=\"javascript:" . $onClick . "\" class=\"toolbar\">" . "<span class=\"icon-32-cancel\" type=\"Standard\">" . "</span>" . JText::_ ( 'Cancel' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'cancel' );
	}
	
	function cancelRead() {
		if (INBOX_PU_READ_MSG && JRequest::getVar ( "tmpl" ) == "component") {
			$onClick = "parent.Shadowbox.close();";
		} else {
			$onClick = "inbSendForm( 'cancelRead' );";
		}
		
		$html = "<a href=\"javascript:" . $onClick . "\" class=\"toolbar\">" . "<span class=\"icon-32-cancel\" type=\"Standard\">" . "</span>" . JText::_ ( 'Cancel' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'cancel' );
	}
	
	function compose($types) {
		$types_html = jinbHelper::typesMenu ( $types );
		if (count ( $types ) > 1) {
		    $html = "<script>
		   		var types_popUp = null;
				window.addEvent('domready', function() {
    				
    				types_popUp = felixPopUp_v2.newPopUp( {pos_mode:'bottom', slide_mode:'vertical', duration:500, duration_close:200, scope_class:'popup_scope'} );  	
               		types_popUp.attachChild( 'jinbTypes', 'jinbTypeMenu' );
           		});
           		</script>"; 
			$html .= "<a href=\"javascript:void(0);\" onClick='types_popUp.toggle( this );' title='" . JText::_ ( "Compose new message" ) . "' class=\"toolbar\" id='jinbTypes'>" . "<span class=\"icon-32-compose\" type=\"Standard\">" . "</span>" . JText::_ ( 'Compose' ) . "</a>" . "<div id='jinbTypeMenu'><div><div><div>" . $types_html . "</div></div></div></div>";
			
		} else {
			$tmpl = INBOX_PU_COMPOSE ? "&tmpl=component" : "";
			$lang = JRequest::getVar ( 'lang' ) ? "&lang=" . JRequest::getVar ( 'lang' ) : "";
			$Itemid = JRequest::getVar ( 'Itemid' ) ? "&Itemid=" . JRequest::getVar ( 'Itemid' ) : "";
			
			$composeUid = uniqid ( 'compose' );
			
			$html = "<a id=\"$composeUid\" href='" . JRoute::_ ( "index.php?option=com_jsinbox&task=compose" . $tmpl . "&type_id=" . @$types [0]->id . $Itemid . $lang ) . "' title='" . JText::_ ( "Compose new message" ) . "' class=\"toolbar\">" . "<span class=\"icon-32-compose\" type=\"Standard\">" . "</span>" . JText::_ ( 'Compose' ) . "</a>";
			
		}
		
		if (INBOX_PU_COMPOSE) {
			ob_start ();
			if (count ( $types ) > 1) {
			?>
			<script>
			
	      	window.addEvent('domready', function() {
	          	var els = $ES('a', 'jinbTypeMenu');
	          	els.each( function(el) {
		      		var href = el.getProperty('href');
		      		
		      		el.addEvent('click', function(e) {

		      			Shadowbox.open({
		       				content: href,
		       				title: el.getProperty('title'),
		       				player: 'iframe',
		       				width: 800,
		       				height: 600
		       			});
		       			
		       			if (types_popUp.state == 'showed')
		       				types_popUp.toggle($('jinbTypeMenu'));

	       				return false;
		      		});

					el.href = 'javascript:void(0);';
	            });
	      	});
	      </script>
			<?php
			}else{
			?>
			<script>
			
	      	window.addEvent('domready', function() {
	          	var el = $('<?php echo $composeUid; ?>');
	          	var href = el.getProperty('href');
		      		
	      		el.addEvent('click', function(e) {

	      			Shadowbox.open({
	       				content: href,
	       				title: el.getProperty('title'),
	       				player: 'iframe',
	       				width: 800,
	       				height: 600
	       			});
	       			
       				return false;
	      		});

				el.href = 'javascript:void(0);';
	            });
    		  </script>	
			<?php 
			}
			$html .= ob_get_clean ();
		}
		
		parent::appendButton ( 'Custom', $html, 'compose' );
	}
	
	function replySingleAll() {
		$lang = JRequest::getVar ( 'lang' ) ? "&lang=" . JRequest::getVar ( 'lang' ) : "";
		$Itemid = JRequest::getVar ( 'Itemid' ) ? "&Itemid=" . JRequest::getVar ( 'Itemid' ) : "";
		
		if (INBOX_PU_READ_MSG) {
			if (INBOX_PU_COMPOSE && JRequest::getVar ( 'tmpl' ) == 'component') {
				$html = "<a href='javascript:parent.jinbResend( \"jinbLinkReplyAll\", " . (INBOX_PU_COMPOSE ? 1 : 0) . ", \"" . JRequest::getVar ( "iid" ) . "\", " . (INBOX_PU_READ_MSG ? 1 : 0) . " );' class=\"toolbar\">";
			} else {
				$html = "<a href=\"javascript:parent.location = 'index.php?option=com_jsinbox&task=resend&context=reply_all&cid[]=" . JRequest::getVar ( "iid" ) . $lang . $Itemid . "'\" class=\"toolbar\">";
			}
		} else {
			if (INBOX_PU_COMPOSE) {
				$tmpl = "&tmpl=component";
				$rel = "rel='shadowbox;width=800;height=600'";
				$html = "<a href='" . JRoute::_ ( "index.php?option=com_jsinbox&task=resend&context=reply_all&cid[]=" . JRequest::getVar ( "iid" ) . $tmpl . $lang . $Itemid ) . "' " . $rel . " id='jinbLinkReply' class=\"toolbar\">";
			} else {
				$html = "<a href=\"" . JRoute::_ ( "index.php?option=com_jsinbox&task=resend&context=reply_all&cid[]=" . JRequest::getVar ( "iid" ) . $lang . $Itemid ) . "\" class=\"toolbar\">";
			}
		}
		$html .= "<span class=\"icon-32-reply_all\" type=\"Standard\">" . "</span>" . JText::_ ( 'Reply All' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'reply_all' );
	}
	
	function replySingle() {
		$lang = JRequest::getVar ( 'lang' ) ? "&lang=" . JRequest::getVar ( 'lang' ) : "";
		$Itemid = JRequest::getVar ( 'Itemid' ) ? "&Itemid=" . JRequest::getVar ( 'Itemid' ) : "";
		
		if (INBOX_PU_READ_MSG) {
			if (INBOX_PU_COMPOSE && JRequest::getVar ( 'tmpl' ) == 'component') {
				$html = "<a href='javascript:parent.jinbResend( \"jinbLinkReply\", " . (INBOX_PU_COMPOSE ? 1 : 0) . ", \"" . JRequest::getVar ( "iid" ) . "\", " . (INBOX_PU_READ_MSG ? 1 : 0) . " );' class=\"toolbar\">";
			} else {
				$html = "<a href=\"javascript:parent.location = 'index.php?option=com_jsinbox&task=resend&context=reply&cid[]=" . JRequest::getVar ( "iid" ) . $lang . $Itemid . "'\" class=\"toolbar\">";
			}
		} else {
			if (INBOX_PU_COMPOSE) {
				$tmpl = "&tmpl=component";
				$rel = "rel='shadowbox;width=800;height=600'";
				$html = "<a href='" . JRoute::_ ( "index.php?option=com_jsinbox&task=resend&context=reply&cid[]=" . JRequest::getVar ( "iid" ) . $tmpl . $lang . $Itemid ) . "' " . $rel . " id='jinbLinkReply' class=\"toolbar\">";
			} else {
				$html = "<a href=\"" . JRoute::_ ( "index.php?option=com_jsinbox&task=resend&context=reply&cid[]=" . JRequest::getVar ( "iid" ) . $lang . $Itemid ) . "\" class=\"toolbar\">";
			}
		}
		$html .= "<span class=\"icon-32-reply\" type=\"Standard\">" . "</span>" . JText::_ ( 'Reply' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'reply' );
	}
	
	function reply() {
		$lang = JRequest::getVar ( 'lang' ) ? "&lang=" . JRequest::getVar ( 'lang' ) : "";
		$Itemid = JRequest::getVar ( 'Itemid' ) ? "&Itemid=" . JRequest::getVar ( 'Itemid' ) : "";
		
		$tmpl = INBOX_PU_COMPOSE ? "&tmpl=component" : "";
		$rel = INBOX_PU_COMPOSE ? "rel='shadowbox;width=800;height=600'" : "";
		$html = "<a href='index.php?option=com_jsinbox&task=resend&context=reply" . $tmpl . $lang . $Itemid . "' " . $rel . " style='display:none' id='jinbLinkReply'>.</a>";
		$html .= "<a href='index.php?option=com_jsinbox&task=resend&context=reply_all" . $tmpl . $lang . $Itemid . "' " . $rel . " style='display:none' id='jinbLinkReplyAll'>.</a>";
		
		$html .= "<a href=\"javascript:void(0);\" onclick=\"jinbResend( 'jinbLinkReply', '" . (INBOX_PU_COMPOSE ? 1 : 0) . "' );\" class=\"toolbar\">" . "<span class=\"icon-32-reply\" type=\"Standard\">" . "</span>" . JText::_ ( 'Reply' ) . "</a>";
		
		//print'<script>Shadowbox.setup();</script>';
		parent::appendButton ( 'Custom', $html, 'reply' );
	}
	
	function forwardSingle() {
		$lang = JRequest::getVar ( 'lang' ) ? "&lang=" . JRequest::getVar ( 'lang' ) : "";
		$Itemid = JRequest::getVar ( 'Itemid' ) ? "&Itemid=" . JRequest::getVar ( 'Itemid' ) : "";
		
		if (INBOX_PU_READ_MSG) {
			if (INBOX_PU_COMPOSE && JRequest::getVar ( 'tmpl' ) == 'component') {
				$html = "<a href='javascript:parent.jinbResend( \"jinbLinkForward\", " . (INBOX_PU_COMPOSE ? 1 : 0) . ", \"" . JRequest::getVar ( "iid" ) . "\", " . (INBOX_PU_READ_MSG ? 1 : 0) . " );' class=\"toolbar\">";
			} else {
				$html = "<a href=\"javascript:parent.location = 'index.php?option=com_jsinbox&task=resend&context=forward&cid[]=" . JRequest::getVar ( "iid" ) . $lang . $Itemid . "'\" class=\"toolbar\">";
			}
		} else {
			if (INBOX_PU_COMPOSE) {
				$tmpl = "&tmpl=component";
				$rel = "rel='shadowbox;width=800;height=600'";
				$html = "<a href='" . JRoute::_ ( "index.php?option=com_jsinbox&task=resend&context=forward&cid[]=" . JRequest::getVar ( "iid" ) . $tmpl . $lang . $Itemid ) . "' " . $rel . " id='jinbLinkReply' class=\"toolbar\">";
			} else {
				$html = "<a href=\"" . JRoute::_ ( "index.php?option=com_jsinbox&task=resend&context=forward&cid[]=" . JRequest::getVar ( "iid" ) . $lang . $Itemid ) . "\" class=\"toolbar\">";
			}
		}
		
		$html .= "<span class=\"icon-32-forward\" type=\"Standard\">" . "</span>" . JText::_ ( 'Forward' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'forward' );
	}
	
	function forward() {
		$lang = JRequest::getVar ( 'lang' ) ? "&lang=" . JRequest::getVar ( 'lang' ) : "";
		$Itemid = JRequest::getVar ( 'Itemid' ) ? "&Itemid=" . JRequest::getVar ( 'Itemid' ) : "";
		
		$tmpl = INBOX_PU_COMPOSE ? "&tmpl=component" : "";
		$rel = INBOX_PU_COMPOSE ? "rel='shadowbox;width=800;height=600'" : "";
		$html = "<a href='index.php?option=com_jsinbox&task=resend&context=forward" . $tmpl . $lang . $Itemid . "' " . $rel . " style='display:none' id='jinbLinkForward'>.</a>";
		
		$html .= "<a href=\"javascript:void(0);\" onclick=\"jinbResend( 'jinbLinkForward', '" . (INBOX_PU_COMPOSE ? 1 : 0) . "' );\" class=\"toolbar\">" . "<span class=\"icon-32-forward\" type=\"Standard\">" . "</span>" . JText::_ ( 'Forward' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'forward' );
	}
	
	function folders($folders) {
		$Itemid = JRequest::getInt('Itemid');
		$folders_html = jinbHelper::folderMenu ( $folders );
		$root = JURI::root();
		
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: void(0); folders_popUp.toggle( this );\" class=\"toolbar\" id='jinbFoders'>" . "<span class=\"icon-32-folders\" type=\"Standard\" id='jinbFolderTool'>" . "</span>" . "<span class=\"icon-32-loading\" style='display:none' type=\"Standard\" id='jinbFolderToolLoading'>" . "</span>" . JText::_ ( 'Folders' ) . "</a>" . "<div id='jinbFolderMenu'><div><div><div id='jinbFolderMenu_'>" . $folders_html . "</div></div></div></div>" . 
		"<script type='text/javascript'>
           var folders_popUp = felixPopUp_v2.newPopUp( {pos_mode:'bottom', slide_mode:'vertical', duration:500, duration_close:200, scope_class:'popup_scope'} );
           	window.addEvent('domready', function() {
	            folders_popUp.attachChild( 'jinbFoders', 'jinbFolderMenu' );
	            $('new_folder_btn_h').addEvent('click', function() {
	            	if (folders_popUp.state == 'showed') {
	            		folders_popUp.toggle($('jinbFoders'));
	            	}
	            });
	            
	            // Shadowbox.setup();
	        });
	        
             function jinbRedrawFolderMenu()
             {
               var tool        = document.getElementById( 'jinbFolderTool' );
               var toolLoading = document.getElementById( 'jinbFolderToolLoading' );
               tool.style.display        = 'none';
               toolLoading.style.display = 'block';
               xajax_redrawFoldersMenu( \"jinbFolderMenu_\", false, $Itemid);
               // folders_popUp.slideOut( 'jinbFoders', 'xajax_redrawFoldersMenu( \"jinbFolderMenu_\" );' );
               
               tool.style.display        = 'block';
               toolLoading.style.display = 'none';
             }
             function jinbShowRedrawedFolderMenu()
             {
               var tool        = document.getElementById( 'jinbFolderTool' );
               var toolLoading = document.getElementById( 'jinbFolderToolLoading' );
               tool.style.display        = 'block';
               toolLoading.style.display = 'none';
               Shadowbox.setup();
               folders_popUp.slideIn( 'jinbFoders' );
             }
             function jinbFolderRemoveButton( folder_id )
             {
               if( ! window.confirm('" . JText::_ ( "All messages in this folder will be permanently deleted. Do you real want to remove this folder?", true ) . "') ) return;
               var button = document.getElementById( 'jinbFolderRemoveButton'+folder_id );
               button.src = 'components/com_jsinbox/images/loading.gif';
               xajax_removeFolder( folder_id );
             }
           </script >";
		
		parent::appendButton ( 'Custom', $html, 'folders' );
	}
	
	function trash() {
		$html = "<a href=\"javascript:void(0);\" onclick=\"jinbListForm( 'toTrash' );\" class=\"toolbar\">" . "<span class=\"icon-32-trash\" type=\"Standard\">" . "</span>" . JText::_ ( 'Trash' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'trash' );
	}
	
	function trashSingle() {
		
		$lang = JRequest::getVar ( 'lang' ) ? "&lang=" . JRequest::getVar ( 'lang' ) : "";
		$Itemid = JRequest::getVar ( 'Itemid' ) ? "&Itemid=" . JRequest::getVar ( 'Itemid' ) : "";
		
		/*$tmpl = INBOX_PU_READ_MSG ? "&tmpl=component" : "";
    $rel  = INBOX_PU_READ_MSG ? "rel='shadowbox;width=800;height=600'" : "";*/
		
		$html = "<a  href=\"" . JRoute::_ ( "index.php?option=com_jsinbox&controller=inbox&view=inbox&task=toTrashSingle&cid[]=" . JRequest::getVar ( "iid" ) )./*$tmpl.*/$lang . $Itemid . "\" class=\"toolbar\">" . "<span class=\"icon-32-trash\" type=\"Standard\">" . "</span>" . JText::_ ( 'Trash' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'trash' );
	}
	
	function delete() {
		$html = "<a href=\"javascript:void(0);\" onclick=\"jinbListForm( 'delete' );\" class=\"toolbar\">" . "<span class=\"icon-32-delete\" type=\"Standard\">" . "</span>" . JText::_ ( 'Delete' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'delete' );
	}
	
	function cleanTrash() {
		$html = "<a href=\"javascript:void(0);\" onclick=\"jinbListForm( 'cleanTrash' );\" class=\"toolbar\">" . "<span class=\"icon-32-clean_trash\" type=\"Standard\">" . "</span>" . JText::_ ( 'Clean' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'clean_trash' );
	}
	
	function restore() {
		$html = "<a href=\"javascript:void(0);\" onclick=\"jinbListForm( 'restore' );\" class=\"toolbar\">" . "<span class=\"icon-32-restore\" type=\"Standard\">" . "</span>" . JText::_ ( 'Restore' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'restore' );
	}
	
	function config() {
		$controlId = uniqid ( 'options' );
		
		$tmpl = "";
		$rel = "";
		if (INBOX_PU_USER_OPTIONS) {
			$tmpl = "&tmpl=component";
		}
		
		$lang = JRequest::getVar ( 'lang' ) ? "&lang=" . JRequest::getVar ( 'lang' ) : "";
		$Itemid = JRequest::getVar ( 'Itemid' ) ? "&Itemid=" . JRequest::getVar ( 'Itemid' ) : "";
		
		$html = "<a id=\"$controlId\" href=\"" . JRoute::_ ( "index.php?option=com_jsinbox&controller=options" . $tmpl . $Itemid . $lang ) . "\" title='" . JText::_ ( "User options" ) . "' class=\"toolbar\">" . "<span class=\"icon-32-config\" type=\"Standard\">" . "</span>" . JText::_ ( 'Options' ) . "</a>";
		
		if (INBOX_PU_USER_OPTIONS) {
			ob_start ();
			?>
<script type="text/javascript">
      	window.addEvent('domready', function() {
          	var el = $('<?php
			echo $controlId;
			?>');
          	
      		el.addEvent('click', function(e) {
	       		e = new Event(e);
	       		e.stop();
	       		
       			Shadowbox.open({
       				content: el.getProperty('href'),
       				title: el.getProperty('title'),
       				player: 'iframe',
       				width: 650,
       				height: 700
       			});
      		});
      	});
      	</script>
<?php
			$html .= ob_get_clean ();
		}
		
		parent::appendButton ( 'Custom', $html, 'config' );
	}
	
	function moveSingle($folders, $currentFolder) {
		$folders_html = jinbHelper::moveFolderMenu ( $folders, $currentFolder );
		
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: void(0); moveFolders_popUp.toggle( this );\" class=\"toolbar\" id='jinbMoveFolders'>" . "<span class=\"icon-32-move\" type=\"Standard\">" . "</span>" . JText::_ ( 'Move' ) . "</a>" . "<div id='jinbMoveFolderMenu'><div><div><div>" . $folders_html . "</div></div></div></div>" . "<script type='text/javascript'>
           		var moveFolders_popUp = felixPopUp_v2.newPopUp( {pos_mode:'bottom', slide_mode:'vertical', duration:500, duration_close:200, scope_class:'popup_scope'} );
           		window.addEvent('domready', function() {
                	moveFolders_popUp.attachChild( 'jinbMoveFolders', 'jinbMoveFolderMenu' );
                });
                 
                 function jinbMoveFolders( from, cfrom, to )
                 {
                   var form = document.adminForm;
                   
                   form.task.value = 'move';
                   form.controller.value = 'inbox';
                   
                   FelixLib_v1.appendFormHidden( 'cid[]', '" . JRequest::getVar ( "iid" ) . "',  form);
                   FelixLib_v1.appendFormHidden( 'from',  from,  form);
                   FelixLib_v1.appendFormHidden( 'cfrom', cfrom, form);
                   FelixLib_v1.appendFormHidden( 'to',    to,    form);
                   
                   form.submit();
                 }
             </script>";
		
		parent::appendButton ( 'Custom', $html, 'move' );
	}
	
	function move($folders, $currentFolder) {
		$folders_html = jinbHelper::moveFolderMenu ( $folders, $currentFolder );
		
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: void(0); jinbOpenMoveMenu( this );\" class=\"toolbar\" id='jinbMoveFolders'>" . "<span class=\"icon-32-move\" type=\"Standard\" id='jinbMoveTool'>" . "</span>" . "<span class=\"icon-32-loading\" style='display:none' type=\"Standard\" id='jinbMoveToolLoading'>" . "</span>" . JText::_ ( 'Move' ) . "</a>" . "<div id='jinbMoveFolderMenu'><div><div><div id='jinbMoveMenu_'>" . $folders_html . "</div></div></div></div>" . "<script type='text/javascript'>
           		 var moveFolders_popUp = felixPopUp_v2.newPopUp( {pos_mode:'bottom', slide_mode:'vertical', duration:500, duration_close:200, scope_class:'popup_scope'} );
           		 window.addEvent('domready', function() {
                 	moveFolders_popUp.attachChild( 'jinbMoveFolders', 'jinbMoveFolderMenu' );
                 });
                 
                 function jinbRedrawMoveMenu()
                 {
                   var tool        = document.getElementById( 'jinbMoveTool' );
                   var toolLoading = document.getElementById( 'jinbMoveToolLoading' );
                   tool.style.display        = 'none';
                   toolLoading.style.display = 'block';
                   if( moveFolders_popUp.state == 'hidden' ) {
                     xajax_redrawMoveMenu( 'jinbMoveMenu_' );
                   } else {
                     moveFolders_popUp.slideOut( 'jinbFoders', 'xajax_redrawMoveMenu( \"jinbMoveMenu_\" );' );
                   }
                 }
                 function jinbShowRedrawedMoveMenu()
                 {
                   var tool        = document.getElementById( 'jinbMoveTool' );
                   var toolLoading = document.getElementById( 'jinbMoveToolLoading' );
                   tool.style.display        = 'block';
                   toolLoading.style.display = 'none';
                   Shadowbox.setup();
                 }
                 
                 function jinbOpenMoveMenu( link )
                 {
                   var form = document.adminForm;
                   if( !form.boxchecked.value || form.boxchecked.value == 0) {
                     alert( '" . JText::_ ( 'No messages are selected' ) . "' );
                     return;
                   }
                   
                   moveFolders_popUp.toggle( link );
                 }
                 
                 function jinbMoveFolders( from, cfrom, to )
                 {
                   var form = document.adminForm;

                   if( !form.boxchecked.value || form.boxchecked.value == 0) {
                     alert( '" . JText::_ ( 'No messages are selected' ) . "' );
                     return;
                   }
                   
                   form.task.value = 'move';
                   form.controller.value = 'inbox';
                   
                   FelixLib_v1.appendFormHidden( 'from',  from,  form);
                   FelixLib_v1.appendFormHidden( 'cfrom', cfrom, form);
                   FelixLib_v1.appendFormHidden( 'to',    to,    form);
                   
                   form.submit();
                 }
             </script>";
		
		parent::appendButton ( 'Custom', $html, 'move' );
	}
	
	function printViewSingle() {
		if (INBOX_PU_READ_MSG && JRequest::getVar ( "tmpl" ) == "component") {
			$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: parent.jinbPreview( 'print', '" . JRequest::getVar ( "iid" ) . "' );\" class=\"toolbar\">";
		} else {
			$html = "<a href=\"" . JRoute::_ ( "index.php?option=com_jsinbox&controller=inbox&task=read&cid[]=" . JRequest::getVar ( "iid" ) . "&context=print&no_xajax=1&tmpl=component" ) . "\" target=\"blank\" class=\"toolbar\">";
		}
		
		$html .= "<span class=\"icon-32-print\" type=\"Standard\">" . "</span>" . JText::_ ( 'Print' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'print' );
	}
	
	function printView() {
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: jinbPreview( 'print' );\" class=\"toolbar\">" . "<span class=\"icon-32-print\" type=\"Standard\">" . "</span>" . JText::_ ( 'Print' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'print' );
	}
	
	function pdfSingle() {
		
		if (INBOX_PU_READ_MSG && JRequest::getVar ( "tmpl" ) == "component") {
			$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: parent.jinbPreview( 'PDF', '" . JRequest::getVar ( "iid" ) . "' );\" class=\"toolbar\">";
		} else {
			$html = "<a href=\"" . JRoute::_ ( "index.php?option=com_jsinbox&controller=inbox&task=read&cid[]=" . JRequest::getVar ( "iid" ) . "&format=pdf&no_xajax=1&tmpl=component" ) . "\" target=\"blank\" class=\"toolbar\">";
		}
		
		$html .= "<span class=\"icon-32-pdf\" type=\"Standard\">" . "</span>" . JText::_ ( 'PDF' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'pdf' );
	}
	
	function pdf() {
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: jinbPreview( 'PDF' );\" class=\"toolbar\">" . "<span class=\"icon-32-pdf\" type=\"Standard\">" . "</span>" . JText::_ ( 'PDF' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'pdf' );
	}
	
	function newPreset() {
		$html = "<a href=\"javascript:void(0);\" onclick=\"jinbSendForm( 'newPreset' );\" class=\"toolbar\">" . "<span class=\"icon-32-new\" type=\"Standard\">" . "</span>" . JText::_ ( 'New' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'trash' );
	}
	
	function editPreset() {
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: void(0); jinbSendForm( 'edit', true );\" class=\"toolbar\">" . "<span class=\"icon-32-edit\" type=\"Standard\">" . "</span>" . JText::_ ( 'Edit' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'edit' );
	}
	
	function removePreset() {
		$html = "<a href=\"javascript:void(0);\" onclick=\"jinbSendForm( 'remove', true );\" class=\"toolbar\">" . "<span class=\"icon-32-delete\" type=\"Standard\">" . "</span>" . JText::_ ( 'Remove' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'Remove' );
	}
	
	function cancelPreset() {
		$onClick = INBOX_PU_PRESET_MANAGER ? "parent.location = parent.location;" : "jinbSendForm(\"cancel\")";
		$html = "<a href=\"javascript:void(0);\" onclick='" . $onClick . "' class=\"toolbar\">" . "<span class=\"icon-32-cancel\" type=\"Standard\">" . "</span>" . JText::_ ( 'Cancel' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'cancel' );
	}
	
	function applyPreset() {
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: void(0); jinbSendForm( 'apply' );\" class=\"toolbar\">" . "<span class=\"icon-32-apply\" type=\"Standard\">" . "</span>" . JText::_ ( 'Apply' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'apply' );
	}
	
	function savePreset() {
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: void(0);  jinbSendForm( 'save' );\" class=\"toolbar\">" . "<span class=\"icon-32-save\" type=\"Standard\">" . "</span>" . JText::_ ( 'Save' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'save' );
	}
	
	function cancelEditPreset() {
		$html = "<a href=\"javascript:void(0);\" onclick='jinbSendForm(\"cancelEdit\")' class=\"toolbar\">" . "<span class=\"icon-32-cancel\" type=\"Standard\">" . "</span>" . JText::_ ( 'Cancel' ) . "</a>";
		
		parent::appendButton ( 'Custom', $html, 'cancel' );
	}
}
?>