<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyMessage by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.model');
class InboxModelFolders extends JModel
{
  var $_folders = array();
  
  function __construct()
  {
    parent::__construct();
  
  }

  function getFolder( $id, $core_folder )
  {
    if( $core_folder ) {
      $folder = jinbHelper::getCoreFolders( $core_folder ); 
    } else {
      $folder = & JTable::getInstance( 'Folders', 'Table' );
      $folder->load( $id ); 
    }
    
    return $folder; 
  }
  
  function getFolders( & $user )
  {
    if( !isset( $this->_folders[$user->get( 'id' )] ) ) {
      $f = jinbHelper::getCoreFolders();
      
      $coreFolders = array();
      $coreFolders[] = $f['inbox']; 
      $coreFolders[] = $f['draft'];
      $coreFolders[] = $f['sent'];
      $coreFolders[] = $f['junk'];
      $coreFolders[] = $f['trash'];
      
      $query = "    SELECT f.*, count(i.id) AS count_messages"
            ."\n      FROM #__js_inbox_folders AS f "
            ."\n LEFT JOIN #__js_inbox AS i ON i.folder_id = f.id AND i.trash = 0"
            ."\n     WHERE f.user_id = ".$user->get( 'id' )." OR f.global > 0"
            ."\n  GROUP BY f.id "
            ."\n  ORDER BY f.global DESC, f.purpose, f.title"
            ;
      
      $folders = $this->_getList( $query, $this->getState( 'limitstart' ), $this->getState( 'limit' ) );
      
      $this->_folders[$user->get( 'id' )] = array_merge( $coreFolders, $folders );
    }
    return $this->_folders[$user->get( 'id' )];
  }
  
  function getIcons()
  {
    $icons = array();
    $files = JFolder::files( JSPATH_INBOX_SITE.DS.'images'.DS.'folders', '\.jpg|\.jpeg|\.png|\.bmp|.gif$', false, false, array( 'draft.png', 'sent.png', 'trash.png') );
    if( $files ) {
      foreach( $files as $key => $file ) {
        $icons[$key] = new stdClass();  
        $icons[$key]->file = $file;
        $icons[$key]->name = ucfirst( str_replace( "_", " ", substr( $file, 0, strrpos ( $file, "." ) ) ) );
      }
    }
    return $icons; 
  }
  
  function store( $post )
  {
    $tFolder = & JTable::getInstance( 'Folders', 'Table' );
    
    if( ! jinbHelper::canSetFolderGlobal() ) {
      unset( $post['global'] );
    }
    
    if ( !$post[ 'title' ] ) {
      $this->setError( JText::_( "Title is empty" ) );
      return false;
    }
    
    $tFolder->bind( $post );
    if( ! $tFolder->store() ) {
      $this->setError( $tFolder->getError() );
      return false;
    } else {
      return $tFolder;
    }
  }
}

?>