<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyMessage by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.model');
class InboxModelInbox extends JModel
{
  var $_pagination     = null;
  var $_messages       = null;
  var $_trash_messages = null;
  var $_total          = null;
  var $_trashTotal     = null;
  
  var $_message        = array();
  
  function __construct()
  {
    parent::__construct();
    
    global $mainframe, $option;
      
    $config = JFactory::getConfig();
  
    $this->setState( 'limit',      $mainframe->getUserStateFromRequest( $option.'.limit', 'limit', INBOX_LIST_MESSAGES_LIMIT, 'int' ) );
    if( JRequest::getInt( 'limit', 0 ) ) {    
      $this->setState( 'limitstart', 0 );
    } else {
      $this->setState( 'limitstart', JRequest::getInt( 'limitstart', 0 ) );
    }
  }
  
  function getMsgStatus( $msg_id )
  {
    $db = $this->getDBO();
    
    $query = "   SELECT relation_type"
          ."\n     FROM #__js_inbox_messages"
          ."\n    WHERE parent_id = ".$msg_id
          ."\n ORDER BY ctime DESC"
          ."\n    LIMIT 0, 1"
          ;
    
    $db->setQuery( $query );
    $last_relation = $db->loadResult();
    
    return $last_relation;
  } 
  
  function getMessageChain( $fromMsg )
  {
    $result = array();
    $lastParent = $fromMsg;
    while( true ) {
      $tMessages = & JTable::getInstance( 'Messages', 'Table' );
      $tMessages->load( $lastParent );
      $result[] = $tMessages;
      $lastParent = $tMessages->get( "parent_id" );
      if( !$lastParent ) break;
    }

    return $result; 
  }
  
  function cleanTrash()
  {
    $user = JFactory::getUser();
    
    $tables = array( "#__js_inbox",
                     "#__js_inbox_draft",
                     "#__js_inbox_sent",
                     "#__js_inbox_junk"
                   );
                   
    foreach( $tables as $table ) {
      
      $query = "SELECT id from ".$table." WHERE trash = 1";
      $this->_db->setQuery( $query );
      $messages = $this->_db->loadResultArray();
      if( count( $messages ) ) {
        $expr = implode( "|", $messages );
        $attachments = JFolder::files( INBOX_UPLOAD_FOLDER.DS.$user->get( "id" ).DS."attachments", "^".$expr, false, true );
        
        foreach( $attachments as $a ) {
          JFile::delete( $a );
        }
      }
      
      $query = "DELETE from ".$table." WHERE trash = 1";
      
      $this->_db->setQuery( $query );
      
      if( !$this->_db->query() ) {
        $this->setError( $this->_db->_errorMsg );
        return false;
      }
    }
    $this->cleanMessages();
    
    return true;
  }
  
  function setRead( $iid )
  {
    preg_match( "#^([0-9]+)_([\_a-z]+)$#", $iid, $msg_ident );
    
    $query = "UPDATE #__".$msg_ident[2]." SET _read = NOW() WHERE id = ".$msg_ident[1];

    $this->_db->setQuery( $query );
    $this->_db->query();
  }
  
  function delete( $cid )
  {
    foreach( $cid as $id ) {
      
      preg_match( "#^([0-9]+)_([\_a-z]+)$#", $id, $msg_ident );
      
      $query = "DELETE from #__".$msg_ident[2]." WHERE id = ".$msg_ident[1];
      
      $this->_db->setQuery( $query );
      
      if( !$this->_db->query() ) {
        $this->setError( $this->_db->_errorMsg );
        return false;
      }
    }
    
    $this->cleanMessages();
    
    return true;
  }
  
  function cleanMessages( )
  {
    $query = "    SELECT m.id, count( i.id ) AS i_id, count( j.id ) AS j_id, count( d.id ) AS d_id, count( s.id ) AS s_id, count( p.id ) AS p_id"
          ."\n      FROM #__js_inbox_messages AS m"
          ."\n LEFT JOIN #__js_inbox          AS i ON i.message_id = m.id"
          ."\n LEFT JOIN #__js_inbox_junk     AS j ON j.message_id = m.id"
          ."\n LEFT JOIN #__js_inbox_draft    AS d ON d.message_id = m.id"
          ."\n LEFT JOIN #__js_inbox_sent     AS s ON s.message_id = m.id"
          ."\n LEFT JOIN #__js_inbox_messages AS p ON p.parent_id = m.id"
          ."\n  GROUP BY m.id"
          ."\n    HAVING i_id = 0 AND j_id = 0 AND d_id = 0 AND s_id = 0 AND p_id = 0"
          ;
    $this->_db->setQuery( $query );
    $report = $this->_db->loadObjectList();
    
    $for_remove = array();
    
    foreach( $report as $msg ) {
      //if( $msg->i_id == 0 && $msg->j_id == 0 && $msg->d_id == 0 && $msg->s_id == 0) {
        $for_remove[] = $msg->id;
      //}
    }
    
    if( count( $for_remove ) ) {
      $query = "DELETE FROM #__js_inbox_messages WHERE id IN( ".implode( ", ", $for_remove )." )";
      $this->_db->setQuery( $query );
      $this->_db->query();
    }
  }
  
  function restore( $cid )
  {
    foreach( $cid as $id ) {
      preg_match( "#^([0-9]+)_([\_a-z]+)$#", $id, $msg_ident );
      
      $query = "UPDATE #__".$msg_ident[2]." SET `trash` = 0 WHERE id = ".$msg_ident[1];
      
      $this->_db->setQuery( $query );
      
      if( !$this->_db->query() ) {
        $this->setError( $this->_db->_errorMsg );
        return false;
      }
    }
    return true;
  }
  
  function toTrash( $cid )
  {
    preg_match( "#^([0-9]+)_([\_a-z]+)$#", $cid[0], $m );
    $table = $m[2];
    
    foreach( $cid as $key => $id ) {
      $cid[ $key ] = JFilterInput::clean( $id, 'INT' );
    }
    
    $query = "UPDATE #__".$table." SET `trash` = 1 WHERE id IN( ".implode( ',', $cid )." )";
    
    $this->_db->setQuery( $query );
    
    if( $this->_db->query() ) {
      return true;
    } else {
      $this->setError( $this->_db->_errorMsg );
      return false;
    }
  }
  
  function getMessage( $ident )
  {
    if ( empty( $this->_message[$ident] ) ) {
      $db = $this->getDBO();
      
      preg_match( "#^([0-9]+)_([\_a-z]+)$#", $ident, $m );
      $table = "#__".$m[2];
      $i_id = $m[1];
      
      $query = "     SELECT *, m.user_id AS user_from, i.user_id AS user_to, m.id AS msg_id, i.id AS inbox_id, t.name AS type_name, '$table' AS _table"
            ."\n       FROM ".$table." AS i"
            ."\n INNER JOIN #__js_inbox_messages AS m ON m.id = i.message_id" 
            ."\n INNER JOIN #__js_inbox_types    AS t ON t.id = m.type_id"
            ."\n      WHERE i.id = ".$i_id
            ."\n   GROUP BY i.id"
            ;
    
      
      $db->setQuery( $query );
      $this->_message[$ident] = $db->loadObject();
    }

    return $this->_message[$ident];
  }
  
  function getMessages( & $folder, & $user, $preset )
  {
    if( $folder->get( 'core' ) == 'trash' ) return $this->getTrashMessages( $user );
    
    if ( empty( $this->_messages ) ) {
      $query = $this->_buildQuery( $folder, $user, $preset );
      $this->_messages = $this->_getList( $query, $this->getState( 'limitstart' ), $this->getState( 'limit' ) );
    }

    return $this->_messages;
  }
  
  function getTrashMessages( & $user )
  {
    if ( ! empty( $this->_trash_messages ) ) {
      return $this->_trash_messages;
    }
    
    $query = $this->_buildTrashQuery( $user );
    
    $this->_trash_messages = $this->_getList( $query, $this->getState( 'limitstart' ), $this->getState( 'limit' ) );
    return $this->_trash_messages;

  }
  
  function _buildTrashQuery( & $user )
  {
    $orderby = $this->_buildTrashOrderBy();

    $query = "(";
    $query.= "     SELECT m.*,"
                        ."m.user_id AS user_from,"
                        ."i.user_id AS user_to,"
                        ."m.id AS msg_id,"
                        ."i.id AS inbox_id,"
                        ."t.name AS type_name,"
                        ."i.flag,"
                        ."i.trash,"
                        ."i._read  AS _read,"
                        ."'#__js_inbox' AS _table,"
                        ."'".JText::_( "Inbox" )."' AS folder"
          ."\n       FROM #__js_inbox AS i "
          ."\n INNER JOIN #__js_inbox_messages AS m ON m.id = i.message_id" 
          ."\n INNER JOIN #__js_inbox_types    AS t ON t.id = m.type_id"
          ."\n      WHERE i.user_id = ".$user->get( 'id' )." AND i.trash = 1 AND i.folder_id=0"
          ."\n   GROUP BY i.id"

        ."\n\n) UNION ALL (\n\n"
            
            ."     SELECT m.*,"
                        ."m.user_id AS user_from,"
                        ."i.user_id AS user_to,"
                        ."m.id AS msg_id,"
                        ."i.id AS inbox_id,"
                        ."t.name AS type_name,"
                        ."i.flag,"
                        ."i.trash,"
                        ."'1' AS _read,"
                        ."'#__js_inbox_draft' AS _table,"
                        ."'".JText::_( "Draft" )."' AS folder"
          ."\n       FROM #__js_inbox_draft AS i "
          ."\n INNER JOIN #__js_inbox_messages AS m ON m.id = i.message_id" 
          ."\n INNER JOIN #__js_inbox_types    AS t ON t.id = m.type_id"
          ."\n      WHERE i.user_id = ".$user->get( 'id' )." AND i.trash = 1"
          ."\n   GROUP BY i.id"
             
        ."\n\n) UNION ALL (\n\n"
            
            ."     SELECT m.*,"
                        ."m.user_id AS user_from,"
                        ."i.user_id AS user_to,"
                        ."m.id AS msg_id,"
                        ."i.id AS inbox_id,"
                        ."t.name AS type_name,"
                        ."i.flag,"
                        ."i.trash,"
                        ."'1' AS _read,"
                        ."'#__js_inbox_sent' AS _table,"
                        ."'".JText::_( "Sent" )."' AS folder"
          ."\n       FROM #__js_inbox_sent AS i "
          ."\n INNER JOIN #__js_inbox_messages AS m ON m.id = i.message_id" 
          ."\n INNER JOIN #__js_inbox_types    AS t ON t.id = m.type_id"
          ."\n      WHERE i.user_id = ".$user->get( 'id' )." AND i.trash = 1"
          ."\n   GROUP BY i.id"
            
        ."\n\n) UNION ALL (\n\n"
            
            ."     SELECT m.*,"
                        ."m.user_id AS user_from,"
                        ."i.user_id AS user_to,"
                        ."m.id AS msg_id,"
                        ."i.id AS inbox_id,"
                        ."t.name AS type_name,"
                        ."i.flag,"
                        ."i.trash,"
                        ."i._read AS _read,"
                        ."'#__js_inbox_junk' AS _table,"
                        ."'".JText::_( "Junk" )."' AS folder"
          ."\n       FROM #__js_inbox_junk AS i "
          ."\n INNER JOIN #__js_inbox_messages AS m ON m.id = i.message_id" 
          ."\n INNER JOIN #__js_inbox_types    AS t ON t.id = m.type_id"
          ."\n      WHERE i.user_id = ".$user->get( 'id' )." AND i.trash = 1"
          ."\n   GROUP BY i.id"
          
        ."\n\n) UNION ALL (\n\n"
   
            ."     SELECT m.*,"
                        ."m.user_id AS user_from,"
                        ."i.user_id AS user_to,"
                        ."m.id AS msg_id,"
                        ."i.id AS inbox_id,"
                        ."t.name AS type_name,"
                        ."i.flag,"
                        ."i.trash,"
                        ."i._read AS _read,"
                        ."'#__js_inbox' AS _table,"
                        ."f.title AS folder"
          ."\n       FROM #__js_inbox AS i "
          ."\n INNER JOIN #__js_inbox_messages AS m ON m.id = i.message_id" 
          ."\n INNER JOIN #__js_inbox_types    AS t ON t.id = m.type_id"
          ."\n INNER JOIN #__js_inbox_folders  AS f ON f.id = i.folder_id"
          ."\n      WHERE i.user_id = ".$user->get( 'id' )." AND i.trash = 1"
          ."\n   GROUP BY i.id"
          

        ."\n\n)"
          ."\n ".$orderby;
    //print '<pre>'.str_replace( "#__", "jos_", $query ).'</pre><br /><br /><br />';
    return $query;
  }
  
  function _buildTrashOrderBy()
  {
    global $mainframe, $option;
    /*$filter_order     = $mainframe->getUserStateFromRequest( $option.'.filter_trash_order',     'filter_order',     'ctime', 'cmd' );
    $filter_order_dir = $mainframe->getUserStateFromRequest( $option.'.filter_trash_order_Dir', 'filter_order_Dir', 'DESC',    'word' );*/
    
    $filter_order     = $mainframe->getUserState( $option.'.inbox.order' );
    $filter_order_dir = $mainframe->getUserState( $option.'.inbox.order_dir' );
    
    switch( $filter_order ) {
      case "m.ctime" :
        $filter_order = "ctime";
        break;
      case "t.id" :
        $filter_order = "type_name";
        break;
      case "m.user_id" :
        $filter_order = "user_from";
        break;
      case "m.subject" :
        $filter_order = "subject";
        break;
      case "i.flag" :
        $filter_order = "flag";
        break;
      case "m.priority" :
        $filter_order = "priority";
        break;
      case "i._read" :
        $filter_order = "_read";
        break;
    }
    
    $orderby = "";
    if ( $filter_order ){
      $orderby  = ' ORDER BY '.$filter_order.' '.$filter_order_dir.' ';
    }
    return $orderby; 
  }
  
  function getTotal( & $folder, & $user, $preset )
  {
    if( $folder->get( 'core' ) == 'trash' ) return $this->getTrashTotal( $user );
    
    if ( empty( $this->_total ) ) {
      $query = $this->_buildQuery( $folder, $user, $preset  );
      $this->_total = $this->_getListCount( $query );
    }

    return $this->_total;
  }

  function getTrashTotal( & $user )
  {
    if ( empty( $this->_trashTotal ) ) {
      $query = $this->_buildTrashQuery( $user );
      $this->_trashTotal = $this->_getListCount( $query );
    }
    
    return $this->_trashTotal;
  }
  
  function getPagination( $total )
  {
    if ( empty( $this->_pagination ) ) {
      jimport( 'joomla.html.pagination' );
      $this->_pagination = new JPagination( $total, $this->getState( 'limitstart' ), $this->getState( 'limit' ) );
    }
    return $this->_pagination;
  }

  function _buildQuery( & $folder, & $user, $preset )
  {
    $where    = $this->_buildWhere( $folder, $user, $preset );
    $order_by = $this->_buildOrderBy( $folder );
    if( isset( $folder->core ) ) {
      switch( $folder->core ) {
        case "draft":
          $table = "#__js_inbox_draft";
          break;
        case "junk":
          $table = "#__js_inbox_junk";
          break;
        case "sent":
          $table = "#__js_inbox_sent";
          break;
        case "inbox":
        default:
          $table = "#__js_inbox";
          break;
      }
    } else {
      $table = "#__js_inbox";
    }
    
    $query = "     SELECT *, m.user_id AS user_from, i.user_id AS user_to, m.id AS msg_id, i.id AS inbox_id, t.name AS type_name, '$table' AS _table"
          ."\n       FROM ".$table." AS i"
          ."\n INNER JOIN #__js_inbox_messages AS m ON m.id = i.message_id" 
          ."\n INNER JOIN #__js_inbox_types    AS t ON t.id = m.type_id"
          ."\n ".$where
          ."\n   GROUP BY i.id"
          ."\n ".$order_by
          ;
          //print $query; exit;
    return $query;
  }
  
  function _buildOrderBy( $folder )
  {
    global $mainframe, $option;

    /*$filter_order		= $mainframe->getUserStateFromRequest( $option.'.filter_order',		'filter_order',		'm.ctime', 'cmd' );
    $filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.filter_order_Dir',	'filter_order_Dir',	'DESC',    'word' );*/
    
    $filter_order     = $mainframe->getUserState( $option.'.inbox.order' );
    $filter_order_dir = $mainframe->getUserState( $option.'.inbox.order_dir' );
    
    $orderby = "";
    if ( $filter_order && !( $folder->get( "core" ) == "draft" && $filter_order == "i._read" ) ){
      $orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_dir.' ';
    } 

    return $orderby;
  }
  
  function _buildWhere( & $folder, & $user, $preset )
  {
    global $mainframe, $option;
    
    $where[] = 'i.user_id = '.$user->get( 'id' );
    $where[] = 'i.trash = 0';
    
    if( $preset->get( 'messages_for_days' ) ) {
      $where[] = 'm.ctime >= ( NOW() - INTERVAL '.$preset->get( 'messages_for_days' ).' DAY )';
    }
    
    if( $folder->get( "core" ) != "draft" ) {
      switch( $preset->get( 'show_by_read' ) ) {
        case "read" :
          $where[] = 'i._read > "0000-00-00 00:00:00"';
          break;
        case "not_read" :
          $where[] = 'i._read = "0000-00-00 00:00:00"';
          break;
      }
    }
    
    switch( $preset->get( 'show_by_replied' ) ) {
      case "replied" :
        $where[] = '( SELECT count( * ) FROM #__js_inbox_messages AS m3 WHERE m3.parent_id = m.id AND m3.relation_type = "reply" ) > 0';
        break;
      case "not_replied" :
        $where[] = '( SELECT count( * ) FROM #__js_inbox_messages AS m2 WHERE m2.parent_id = m.id AND m2.relation_type = "reply" ) = 0';
        break;
    }
   
    switch( $preset->get( 'show_by_forwarded' ) ) {
      case "forwarded" :
        $where[] = '( SELECT count( * ) FROM #__js_inbox_messages AS m4 WHERE m4.parent_id = m.id AND m4.relation_type = "forward" ) > 0';
        break;
      case "not_forwarded" :
        $where[] = '( SELECT count( * ) FROM #__js_inbox_messages AS m5 WHERE m5.parent_id = m.id AND m5.relation_type = "forward" ) = 0';
        break;
    }
    
    $search = $mainframe->getUserState( $option.'.inbox.search' );
    if( $search ) {
      $search = JString::strtolower( $this->_db->getEscaped( $search ) );
      $where_serch[] = "LOWER( m.body ) like '%".$search."%'";
      $where_serch[] = "LOWER( m.subject ) like '%".$search."%'";
      $where[] = "( ".implode( " OR ", $where_serch )." )";
    }
    
    if( isset( $folder->core ) && $folder->core == "inbox" ) {
      $where[] = 'i.folder_id = 0';
    } else if ( !isset( $folder->core ) ) {
      $where[] = 'i.folder_id = '.$folder->get( 'id' );
    }

    return ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );
  }
  
  function getFlags()
  {
    $flags = array();
    $files = JFolder::files( JSPATH_INBOX_SITE.DS.'images'.DS.'flags', '\.jpg|\.jpeg|\.png|\.bmp|.gif$' );
    if( $files ) {
      foreach( $files as $key => $file ) {
        $flags[$key] = new stdClass();  
        $flags[$key]->file = $file;
        $flags[$key]->name = ucfirst( str_replace( "_", " ", substr( $file, 0, strrpos ( $file, "." ) ) ) );
      }
    }
    return $flags; 
  }
  
  function move()
  {
    $to       = JRequest::getInt( 'to' );
    $messages = JRequest::getVar( 'cid' );
    
    foreach( $messages as $key => $id )  {
      $messages[ $key ] = JFilterInput::clean( $id, 'INT' );
    }
    
    $query = "UPDATE #__js_inbox SET `folder_id` = ".$to." WHERE id IN( ".implode( ',', $messages )." )";
    $this->_db->setQuery( $query );
    
    if( $this->_db->query() ) {
      return true;
    } else {
      $this->setError( $this->_db->_errorMsg );
      return false;
    }
  }
  
  function storeMessage( $post, $stored_msg_id = 0 )
  {
    $tMessage = & JTable::getInstance( 'Messages', 'Table' );
    
    if( $stored_msg_id ) {
      $tMessage->load( $stored_msg_id );
    }
    
    $tMessage->bind( $post );
    
    if( ! $tMessage->store() ) {
      $this->setError( $tMessage->getError() );
      return false;
    } else {
      $this->stored_message = $tMessage;
      return $tMessage->id;
    }
  }
  
  function storeMessageInSent( $user_id, $message_id )
  {
    $tSent = & JTable::getInstance( 'Sent', 'Table' );
    
    $tSent->bind( array( "user_id" => $user_id, "message_id" => $message_id ) );
    
    if( ! $tSent->store() ) {
      $this->setError( $tSent->getError() );
      return false;
    } else {
      $this->stored_sent = $tSent;
      return true;
    }
  }
  
  function getTypes()
  {
    $user = JFactory::getUser();
    
    $query = "   SELECT *"
          ."\n     FROM #__js_inbox_types"
          ."\n    WHERE published = 1 ".( in_array( $user->get( 'gid' ), array( 24, 25 ) ) ? "" : " AND can_choose = 1" )
          ."\n ORDER BY name"
          ;

    return $this->_getList( $query );
  }
  
  function assignMessageToUsers( & $message, & $addresses, & $group_addresses, & $problems )
  {
    
    $my = JFactory::getUser();
    
    $send_to_inbox = array();
    $send_to_junk  = array();
    $not_send      = array();
    
    $mHistory = & JModel::getInstance( 'History', 'InboxModel' );
    
    if( class_exists( "JSCommunityApiExtern" ) ) {
        $my_groups = JSCommunityApiExtern::getUserMembershipGroups( $my->get( "id" ) );
    }
    
    /*
       Create sending lists from simple addresses
     */
    
    foreach ( $addresses as $f_key => $field ) {
      
      if( $f_key == "sto_names" ) continue;
      
      foreach( $field as $u_key => $user ) {
        $jinbOptions = $user->get( 'jinbOptions' );
        
        if( $jinbOptions->get( 'disable_inbox' ) ) {
          $not_send[] = $addresses[$f_key][$u_key]->username;
        } else {
          $to_inbox = true;
          
          if( class_exists( "JSCommunityApiExtern" ) ) {

          	  /*
          	     Filter recipients by paraneter "recieve_only_from_friends"
          	   */
          	
	          if( $jinbOptions->get( 'recieve_only_from_friends' ) ) {
		        $recipient_friends = JSCommunityApiExtern::getUserFriends( $user->get( "id" ) );
		          
		        if( ! in_array( $my->get( "id" ), $recipient_friends ) ) {
	              $to_inbox = false;
		        }
	          }
	          
	          /*
                 Filter recipients by paraneter "recieve_only_from_my_groups"
               */
	          
	          if( $to_inbox && $jinbOptions->get( "receive_from_groups" ) ) {
	          	$pecipient_groups = JSCommunityApiExtern::getUserMembershipGroups( $user->get( "id" ) );
	          	$found = false;
	          	foreach( $pecipient_groups as $pecipient_group ) {
	          		if( in_array( $pecipient_group, $my_groups ) ) {
	          			$found = true;
	          		}
	          	}
	          	
	          	if( !$found ) {
	          		$to_inbox = false;
	          	}
	          	/*
	          	if( !is_array( $receive_from_groups ) ) {
	          		$receive_from_groups = trim( $receive_from_groups ) ? array( $receive_from_groups ) : array(); 
	          	}
	          	
	          	foreach( $receive_from_groups as $recipient_group ) {
	          		$matches = explode( "_", $recipient_group );
	          		if( in_array( $matches[0], $my_groups ) && $matches[1] != 1 ) {
	          			$to_inbox = false;
	          			$to_junk_ignore_group = true;
	          		}  
	          	}
	          	*/
	          	
	          }
          }
          
          if( $to_inbox ) {
          	$send_to_inbox[] = & $addresses[$f_key][$u_key];
          } else {
          	$send_to_junk[] = & $addresses[$f_key][$u_key];
          }
        }
        
        /*if( $jinbOptions->get( 'disable_inbox' ) ) {
          $not_send[] = $addresses[$f_key][$u_key]->username;
        } else if( $jinbOptions->get( 'recieve_only_from_friends' ) && class_exists( "JSCommunityApiExtern" ) ) {
          
          $recipient_friends = JSCommunityApiExtern::getUserFriends( $user->get( "id" ) );
          
          if( in_array( $my->get( "id" ), $recipient_friends ) ) {
          	
            $send_to_inbox[] = & $addresses[$f_key][$u_key];
          } else {
            $send_to_junk[] = & $addresses[$f_key][$u_key];
          }
          
        } else {
          $send_to_inbox[] = & $addresses[$f_key][$u_key];
        }*/
      }
    }
    
    /*
       Create sending lists from group addresses
     */
    
    foreach ( $group_addresses as $group_id => $users ) {
      foreach( $users as $u_key => $user ) {
        $jinbOptions = $user->get( 'jinbOptions' );
        
        if( $jinbOptions->get( 'disable_inbox' ) ) {
            $not_send[] = $group_addresses[$group_id][$u_key]->username;
        } else {
        	$to_inbox = true;
        	
        	/*
               Filter recipients by paraneter "recieve_addressed_to_groups"
             */
        	
            $receive_from_groups = $jinbOptions->get( "recieve_addressed_to_groups" );
            if( !is_array( $receive_from_groups ) ) {
                $receive_from_groups = trim( $receive_from_groups ) ? array( $receive_from_groups ) : array(); 
            }
                
            foreach( $receive_from_groups as $recipient_group ) {
                $matches = explode( "_", $recipient_group );
                if( $matches[0] == $group_id && $matches[1] != 1 ) {
                    $to_inbox = false;
                }  
            }
        	
            if( $to_inbox ) {
                $send_to_inbox[] = & $group_addresses[$group_id][$u_key];
            } else {
                $send_to_junk[] = & $group_addresses[$group_id][$u_key];
            }
        }
        
        
        /*
        if( $jinbOptions->get( 'disable_inbox' ) ) {
          $not_send[] = $group_addresses[$group_id][$u_key]->username;
          
        } else if( $jinbOptions->get( 'recieve_only_from_friends' ) && JFolder::exists( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_community' ) ) {
          require_once JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'models'.DS.'profile.php';
          $mProfile = new CommunityModelProfile();
          
          $mProfile->_id = $user->get( 'id' ); 
          
          if( count( $mProfile->getFriends( $my->get( "id" ) ) ) ){
            $send_to_inbox[] = & $group_addresses[$group_id][$u_key];
          } else {
            $send_to_junk[] = & $group_addresses[$group_id][$u_key];
          }
          
        } else {
          $send_to_inbox[] = & $group_addresses[$group_id][$u_key];
        }
        */
      }
    }
    
    if( !count( $send_to_inbox ) && !count( $send_to_junk ) ) {
      $this->setError( "All users will not recieve your message, because they inbox is disabled" );
      return false;
    }
    
    $tInbox = & JTable::getInstance( 'Inbox', 'Table' );
    $tJunk = & JTable::getInstance( 'Junk', 'Table' );
    
    
    foreach( $send_to_inbox as $user ) {
      /* Continue if message box of this user is full */
      $message_progress = $this->getMessageProgress( $user->get( "id" ) );
      if( INBOX_MAX_STORING_MSG && ( $message_progress['count'] >=  $message_progress['max_count'] ) ) continue;
      
      $tInbox->bind( array( 'id' => 0, 'message_id' => $message->get( 'id' ), 'user_id' => $user->get( 'id' ) ) );
      $tInbox->store();

      /* Save copy of message on users email*/
      $jinbOptions = $user->get( 'jinbOptions' );
      if( $jinbOptions->get( 'send_copy_on_email' ) ) {
        $this->sendMailMessageCopy( $user, $message, $tInbox );
      }
      
      /* Save event  */
      $mHistory->onSendMessage( $message->get( 'user_id' ), $user->get( 'id' ), $message->get( 'ctime' ), $message->get( 'id' ) );
      
      /* Add to address book */
      $this->addToAddressBook( $message->get( 'user_id' ), $user->get( 'id' ), $message->get( 'type_id' ) );
    }
    
    foreach( $send_to_junk as $user ) {
      /* Continue if message box of this user is full */
      $message_progress = $this->getMessageProgress( $user->get( "id" ) );
      if( INBOX_MAX_STORING_MSG && ( $message_progress['count'] >=  $message_progress['max_count'] ) ) continue;
      
      $tJunk->bind( array( 'id' => 0, 'message_id' => $message->get( 'id' ), 'user_id' => $user->get( 'id' ) ) );
      $tJunk->store();
      
      /* Save copy of message on users email*/
      /*$jinbOptions = $user->get( 'jinbOptions' );
      if( $jinbOptions->get( 'send_copy_on_email' ) ) {
        $this->sendMailMessageCopy( $user, $message );
      }*/
      
      /* Save event  */
      $mHistory->onSendMessage( $message->get( 'user_id' ), $user->get( 'id' ), $message->get( 'ctime' ), $message->get( 'id' ), 1 );
      
      /* Add to address book */
      $this->addToAddressBook( $message->get( 'user_id' ), $user->get( 'id' ), $message->get( 'type_id' ) );
    }
    if( count( $not_send ) ) {
      $problems .= ( $problems ? "<br />":"");
      $problems .= JText::_( "Next users will not recieve your message, because they inbox is disabled" ).': ';
      if( count( $not_send ) <= 200 ) {
        $problems .= implode( ", ", $not_send );
      } else {
      	$problems .= JText::_( "There are more then 200 users" );
      }
    }
    
    return true;
  }
  
  function addToAddressBook( $from_id, $to_id, $type_id )
  {
    $query = "   SELECT *"
          ."\n     FROM #__js_inbox_address_book"
          ."\n    WHERE user_id_from = ".$from_id." AND user_id_to = ".$to_id." AND type_id = ".$type_id
          ;

    $find_records = $this->_getList( $query );
    if( count( $find_records ) ) {
      $query = "UPDATE #__js_inbox_address_book SET amount = amount + 1 WHERE id = ".$find_records[0]->id;
      $this->_db->setQuery( $query );
      $this->_db->query();
    } else {
      $query = "INSERT INTO #__js_inbox_address_book ( user_id_from, user_id_to, type_id, amount ) VALUES ( ".$from_id.", ".$to_id.", ".$type_id.", 1 )";
      $this->_db->setQuery( $query );
      $this->_db->query();
    }
  }
  
  function sendMailMessageCopy( & $user, & $message, & $inbox_assignment )
  {
    //!JMailHelper::isEmailAddress( $this->email )
    $config      = JFactory::getConfig();
    $jinbOptions = $user->get( 'jinbOptions' );
    
    $mail = JFactory::getMailer();

    $mail->IsHTML( true );
    
    $email_send = $user->get('email');

    
    $sender[0] = $config->getValue('config.mailfrom');
    $sender[1] = $config->getValue('config.fromname');

    $mail->setSender( $sender );
    
    $mail->AddAddress( $user->get( 'email' ) );
    if( JMailHelper::isEmailAddress( $jinbOptions->get( 'addition_email' ) ) ) {
      $mail->AddAddress( $jinbOptions->get( 'addition_email' ) );
    }
    
    $user_from = JFactory::getUser( $message->get( "user_id" ) );
    $ctime = new JDate( $message->get( "ctime" ) );
    
    $addressHelper = new jinbAddressShower;
    $addressHelper->init( $message->get( 'addresses' ), $user->get( "id" ) );
    
    $body = 
            JText::_( "From" )." : ".jinbHelper::showUserName( $user_from, "", false )
            ."<br />".
            JText::_( "To" )." : ".implode( ", ", $addressHelper->show( 'to', false ) )
            ."<br />".
            ( count( $addressHelper->show( 'cc', false ) ) ?  JText::_( "CC" )." : ".implode( ", ", $addressHelper->show( 'cc', false ) )."<br />" : "").
            JText::_( "Date" )." : ".$ctime->toFormat( INBOX_TIME_FORMAT )
            ."<br />"
            ."<br />"
            .$message->get( "subject" )."\n"
            .( $message->get( 'attachments' ) ?
              "<br />"
              ."<br />"
              .JText::_( "Attachment" ).":"
              ."<a target=\"blank\" href=\"".JURI::root()."/index.php?option=com_jsinbox&task=download&no_xajax=1&tmpl=component&file=".$message->get( 'id' )."\">"
                ." <img src=\"".JURI::root()."/components/com_jsinbox/images/clip.png\"> "
                .$message->get( 'attachments' )
              ."</a>"
              ."<br />"
              ."<br />"
            : "" )
            ."<br />"
            .( INBOX_EMAIL_WITH_MSGBODY ? $message->get( "body" )."<br />" : "" )
            .JText::_( "Read this mesage on the site" ).": "
            ."<a href='".JURI::root()."index.php?option=com_jsinbox&controller=inbox&view=read&iid=".$inbox_assignment->get( "id" )."_js_inbox'>
            ".$config->getValue('config.sitename')."</a>";
    $mail->setBody( JMailHelper::cleanBody( $body ) );
        
    $mail->setSubject( JMailHelper::cleanSubject( JText::sprintf( 'You have new message on site "%s" with subject "%s"', $config->getValue('config.sitename'), $message->get( "subject" ) ) ) );
    
    $mail->Send();
  }
  
  /*function userObjectsToAddresses( $users )
  {
    $addresses = array();
    
    if( !count( $users ) ) return $addresses;
    
    foreach ( $users as $user ) {
      $addresses[] = jinbHelper::showUserName( $user );
    }
    
    return $addresses;
  }
  
  function usernamesToUserObjects( $usernames )
  {
    $users = array();
    
    if( !count( $usernames ) ) return $users; 
    
    foreach ( $usernames as $key => $username ) {
      $usernames[$key] = JString::strtolower( $username );
    }
    
    $this->_db->setQuery( "SELECT id FROM #__users WHERE LOWER( username ) IN ( '".implode( "','", $usernames )."' ) " );
    $users = $this->_db->loadResultArray();
    
    foreach( $users as $key => $uid ) {
      $users[ $key ] = & JFactory::getUser( $uid );
    }
    
    return $users;
  }*/
  
  function assignToDraft( $message ) {
    $user = JFactory::getUser();
    
    $tDraft = & JTable::getInstance( 'Draft', 'Table' );
    
    $tDraft->bind( array( 'id' => 0, 'message_id' => $message->get( 'id' ), 'user_id' => $user->get( 'id' ) ) );
    if( $tDraft->store() ) {
      return true;
    } else {
      $this->setError( $tDraft->getError() );
      return false;
    }
  }
  
  function getMessageProgress( $user_id = 0 )
  {
    if( $user_id ) {
      $user = JFactory::getUser( $user_id );
    } else {
      $user = JFactory::getUser();
    }
    
    $progress = 0;
    
    /*$this->_db->setQuery( "SELECT COUNT( id ) FROM #__js_inbox WHERE user_id = ".$user->get( "id" ) );
    $progress += $this->_db->loadResult();
    
    $this->_db->setQuery( "SELECT COUNT( id ) FROM #__js_inbox_draft WHERE user_id = ".$user->get( "id" ) );
    $progress += $this->_db->loadResult();
    
    $this->_db->setQuery( "SELECT COUNT( id ) FROM #__js_inbox_junk WHERE user_id = ".$user->get( "id" ) );
    $progress += $this->_db->loadResult();
    
    $this->_db->setQuery( "SELECT COUNT( id ) FROM #__js_inbox_sent WHERE user_id = ".$user->get( "id" ) );
    $progress += $this->_db->loadResult();
    
    return array( "count" => $progress, "max_count" => INBOX_MAX_STORING_MSG );*/
    
    $this->_db->setQuery( "SELECT COUNT( id ) FROM #__js_inbox WHERE folder_id = 0 AND trash = 0 AND user_id = ".$user->get( "id" ) );
    $progress_inbox = $this->_db->loadResult();
    $this->_db->setQuery( "SELECT COUNT( id ) FROM #__js_inbox WHERE folder_id = 0 AND trash = 0 AND _read = '0000-00-00 00:00:00' AND user_id = ".$user->get( "id" ) );
    $progress_inbox_unread = $this->_db->loadResult();
    
    $this->_db->setQuery( "SELECT COUNT( id ) FROM #__js_inbox WHERE trash = 1 AND user_id = ".$user->get( "id" ) );
    $progress_trash = $this->_db->loadResult();
    
    $this->_db->setQuery( "SELECT COUNT( id ) FROM #__js_inbox WHERE folder_id > 0 AND trash = 0 AND user_id = ".$user->get( "id" ) );
    $progress_other_folders = $this->_db->loadResult();
    
    $this->_db->setQuery( "SELECT COUNT( id ) FROM #__js_inbox_draft WHERE user_id = ".$user->get( "id" ) );
    $progress_draft = $this->_db->loadResult();
    
    $this->_db->setQuery( "SELECT COUNT( id ) FROM #__js_inbox_junk WHERE user_id = ".$user->get( "id" ) );
    $progress_junk = $this->_db->loadResult();
    $this->_db->setQuery( "SELECT COUNT( id ) FROM #__js_inbox_junk WHERE _read = '0000-00-00 00:00:00' AND user_id = ".$user->get( "id" ) );
    $progress_junk_unread = $this->_db->loadResult();
    
    $this->_db->setQuery( "SELECT COUNT( id ) FROM #__js_inbox_sent WHERE user_id = ".$user->get( "id" ) );
    $progress_sent = $this->_db->loadResult();
    
    return array( "count" => $progress_inbox + $progress_trash + $progress_draft + $progress_junk + $progress_sent + $progress_other_folders,
                  "inbox" => $progress_inbox,
                  "inbox_unread" => $progress_inbox_unread,
                  "trash" => $progress_trash,
                  "other_folders" => $progress_other_folders,
                  "draft" => $progress_draft,
                  "junk" => $progress_junk,
                  "junk_unread" => $progress_junk_unread,
                  "sent" => $progress_sent,
                  "max_count" => INBOX_MAX_STORING_MSG );
  }

  function initGroupAddresses( $addresses )
  {
  	$result = array();
  	
  	foreach ( $addresses as $group_ids => $group_id ) {
  		$result[$group_id] = array( );
  		
  		$group_members = JSCommunityApiExtern::getGroupMembers( $group_id );
  		foreach( $group_members as $group_member ) {
  		    $result[$group_id][ $group_member->id ] = & JFactory::getUser( $group_member->id );
  		}
  	}
  	
  	return $result;
  } 
}

?>