<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyMessage by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined ( '_JEXEC' ) or die ();

jimport ( 'joomla.application.component.model' );
class InboxModelOptions extends JModel {
	var $_options = array ();
	
	function __construct() {
		parent::__construct ();
	
	}
	
	function & getComponentParams()
	{
		static $componentParams = null;
		
		if (empty($componentParams))
			$componentParams = new JParameter(JFile::read(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jsinbox'.DS.'config.ini'));
		
		return $componentParams;
	}
	
	function getOptions($user, $default = null) {
		if (! isset ( $this->_options [$user->get ( "id" )] )) {
			if ($default) {
				
				$options = new JINBParameter ( "", JSPATH_INBOX_ADMIN . DS . "user_options.xml" );
				$options->loadArray ( $default );
			} else {
				$ini_file = JFolder::files ( JSPATH_INBOX_SITE . DS . "user_options", "^" . $user->get ( "id" ) . "_", false, true );
				if (count ( $ini_file )) {
					$ini = JFile::read ( $ini_file [0] );
				} else {
					$ini = JFile::read ( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_jsinbox' . DS . 'config.ini' );
				}
				
				$options = new JINBParameter ( $ini, JSPATH_INBOX_ADMIN . DS . "user_options.xml" );
				
				
				$componentParams = & $this->getComponentParams();
				$paramsArray = $componentParams->toArray();
				
				foreach ($paramsArray as $k => $v) {
					if ( ! is_array( $v ))
						$options->def($k, $v);
				}
			}
			$this->_options [$user->get ( "id" )] = $options;
		}
		
		return $this->_options [$user->get ( "id" )];
	}
	
	function store($user, $options) {
		$registry = new JRegistry ( );
		$registry->loadArray ( $options );
		$ini = $registry->toString ();
		
		$ini_file = JSPATH_INBOX_SITE . DS . "user_options" . DS . $user->get ( "id" ) . "_" . preg_replace ( "[^a-z]", "_", strtolower ( $user->get ( "username" ) ) );
		
		if (JFile::write ( $ini_file, $ini )) {
			return true;
		} else {
			$this->setError ( "Can`t rewrite or create ini file" );
			return false;
		}
	}
	
	function setOptionsToAddressList(& $addresses, & $group_addresses) {
		foreach ( $addresses as $f_key => $field ) {
			if ($f_key == "sto_names")
				continue;
			foreach ( $field as $u_key => $user ) {
				$addresses [$f_key] [$u_key]->set ( 'jinbOptions', $this->getOptions ( $user ) );
			}
		}
		
		foreach ( $group_addresses as $group_id => $users ) {
			foreach ( $users as $u_key => $user ) {
				$group_addresses [$group_id] [$u_key]->set ( 'jinbOptions', $this->getOptions ( $user ) );
			}
		}
	}

}