<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyMessage by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.model');
class InboxModelPresets extends JModel
{
  var $_presets = null;
  var $_total   = null;
  
  function __construct()
  {
    parent::__construct();
    
    global $mainframe, $option;
      
    $config = JFactory::getConfig();
  
    $this->setState( 'limit',      $mainframe->getUserStateFromRequest( $option.'.limit', 'limit', INBOX_LIST_MESSAGES_LIMIT, 'int' ) );
    if( JRequest::getInt( 'limit', 0 ) ) {    
      $this->setState( 'limitstart', 0 );
    } else {
      $this->setState( 'limitstart', JRequest::getInt( 'limitstart', 0 ) );
    }
  }
  
  function getPresets( $user_id, $with_limit = true )
  {
    if ( empty( $this->_presets ) ) {
      $query = $this->_buildQuery( $user_id );
      if( $with_limit ) {
        $this->_presets = $this->_getList( $query, $this->getState( 'limitstart' ), $this->getState( 'limit' ) );
      } else {
      	$this->_presets = $this->_getList( $query );
      }
    }

    return $this->_presets;
  }
  
  function _buildQuery( $user_id )
  {
  	$order_by = $this->_buildOrderBy();
    $query = " SELECT *"
          ."\n FROM #__js_inbox_presets AS p"
    //      ."\n LEFT JOIN #__js_inbox_preset_assign AS a ON ".( $core_folder ? " a.core_folder = '".$core_folder."'" : " a.folder_id = ".$folder_id )
          ."\n WHERE p.user_id = ".$user_id." OR global = 1"
          ."\n ".$order_by;
    //print $query;
    return $query; 
  }
  
  function _buildOrderBy()
  {
    global $mainframe, $option;
    
    $filter_order     = $mainframe->getUserState( $option.'.filter_presets_order' );
    $filter_order_Dir = $mainframe->getUserState( $option.'.filter_presets_order_Dir' );
    
    if ( !$filter_order || !$filter_order_Dir ){
      $filter_order     = 'p.title';
      $filter_order_Dir = 'DESC';
    }
    
    $orderby  = ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' ';

    return $orderby;
  }
  
  function getTotal( $user_id )
  {
    if ( empty( $this->_total ) ) {
      $query = $this->_buildQuery( $user_id  );
      $this->_total = $this->_getListCount( $query );
    }

    return $this->_total;
  }
  
  function getPagination( $total )
  {
    if ( empty( $this->_pagination ) ) {
      jimport( 'joomla.html.pagination' );
      $this->_pagination = new JPagination( $total, $this->getState( 'limitstart' ), $this->getState( 'limit' ) );
    }
    return $this->_pagination;
  }
  
  function getFolderPreset( $fid, $fcore, $user_id )
  {
    $tPresets = & JTable::getInstance( 'Presets', 'Table' );
    
    $this->_db->setQuery( " SELECT preset_id"
                       ."\n   FROM #__js_inbox_preset_assign"
                       ."\n  WHERE user_id = ".$user_id." AND ".( $fid ? "folder_id = ".$fid : "core_folder = '".$fcore."'" ) );
    $result = $this->_db->loadObjectList();
    
    if( count( $result ) ) {
      $tPresets->load( $result[0]->preset_id );
    }
    
    return $tPresets; 
  }
  
  function getPreset( $id = 0 ) 
  {
    $tPresets = & JTable::getInstance( 'Presets', 'Table' );
    $tPresets->load( $id );
    return  $tPresets;
  }
  
  function store( $post )
  {
    $tPresets = & JTable::getInstance( 'Presets', 'Table' );
    
    if ( !$post[ 'title' ] ) {
      $this->setError( JText::_( "Title is empty" ) );
      return false;
    }
    
    $tPresets->bind( $post );
    if( ! $tPresets->store() ) {
      $this->setError( $tPresets->getError() );
      return false;
    } else {
      return $tPresets;
    }
  }
  
  function remove( $cid )
  {
    
    $query = "DELETE from #__js_inbox_presets WHERE id IN (".implode( ",", $cid ).")";
    
    $this->_db->setQuery( $query );
    
    if( !$this->_db->query() ) {
      $this->setError( $this->_db->_errorMsg );
      return false;
    }
    return true;
  }
  
  function assignPresetToFolder( $fid, $fcore, $preset_id, $user_id )
  {
    $this->_db->setQuery( " SELECT id"
                       ."\n   FROM #__js_inbox_preset_assign"
                       ."\n  WHERE user_id = ".$user_id." AND ".( $fid ? "folder_id = ".$fid : "core_folder = '".$fcore."'" ) );
    $result = $this->_db->loadObjectList();
    
    if( count( $result ) ) {
      $this->_db->setQuery( " UPDATE #__js_inbox_preset_assign"
                         ."\n    SET  preset_id = ".$preset_id
                         ."\n  WHERE id = ".$result[0]->id );
      $result = $this->_db->query();
    } else {
      $tPresets = & JTable::getInstance( 'Preset_assign', 'Table' );
      $tPresets->bind( array( "folder_id"   => $fid ? $fid : 0,
                              "core_folder" => $fcore,
                              "preset_id"   => $preset_id,
                              "user_id"     => $user_id ) );
      $tPresets->store();
    }
  }
}

?>