<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyMessage by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class InboxViewCompose extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option, $itemid;
		 
		JHTML::_('behavior.tooltip');
		 
		jimport('joomla.html.pane');
		 
		if( JRequest::getVar( "context" ) == "reply" || JRequest::getVar( "context" ) == "forward" ) {
			JRequest::setVar( "relation_type", JRequest::getVar( "context" ) );
		}
		 
		$user     = & JFactory::getUser();
		$uri 	  = & JFactory::getURI();
		$document = & JFactory::getDocument();
		 
		$mInbox   = & JModel::getInstance( 'Inbox',   'InboxModel' );
		$mTypes   = & JModel::getInstance( 'Types',   'InboxModel' );
		$mOptions = & JModel::getInstance( 'Options', 'InboxModel' );
		 
		$pathway    = & $mainframe->getPathway();
		$url_params = & $mainframe->getParams();
		 
		$document->addScript( JURI::root().'components/com_jsinbox/views/compose/tmpl/popup.js' );

		$document->addStyleSheet( JURI::root().'/components/com_jsinbox/css/taber_style.css' );

		$msg_id = JRequest::getInt( "stored_msg_id", 0 );

		$user_options =  $mOptions->getOptions( $user );

		$tMessages = & JTable::getInstance( 'Messages', 'Table' );
		$tMessages->load( $msg_id );

		if( !$msg_id && !$tMessages->get( "body" ) ) {
			$tMessages->set( "body", "<br /><br />".nl2br( $user_options->get( "signature", "" ) ) );
		}

		$msgChain = array();

		if( JRequest::getVar( "task" ) == "resend" ) {
			$ident = JRequest::getVar( "cid" );
			$_parentMsg = $mInbox->getMessage( $ident[0] );
			$parentMsg = & JTable::getInstance( 'Messages', 'Table' );
			$parentMsg->load( $_parentMsg->msg_id );

			switch( JRequest::getVar( "context" ) ) {
				case "reply" :
					$prefix = JText::_( "Re" ).": ";
					$userFrom = &JFactory::getUser( $parentMsg->get( 'user_id' ) );
					$tMessages->setAddresses( "to", array( $userFrom->get( 'username' ) ) );
					break;
				case "reply_all" :
					$prefix = JText::_( "Re" ).": ";
					$userFrom = &JFactory::getUser( $parentMsg->get( 'user_id' ) );

					$addresses = $parentMsg->getAddresses();

					$addresses['to'][$userFrom->get( 'id' )] = $userFrom->get( 'username' );
					if( isset( $addresses['to'] ) ) {
						unset( $addresses['to'][$user->get( 'id' )] );
					}

					if( isset( $addresses['cc'] ) ) {
						unset( $addresses['cc'][$user->get( 'id' )] );
					}

					$tMessages->setAddresses( "group_addresses", array() );
					$tMessages->setAddresses( "sto_names", array() );
					if( isset( $addresses['to'] ) ) {
						$tMessages->setAddresses( "to", $addresses['to'] );
					}
					if( isset( $addresses['cc'] ) ) {
						$tMessages->setAddresses( "cc", $addresses['cc'] );
					}

					break;
				case "forward" :
					$prefix = JText::_( "Fw" ).": ";
					break;
			}

			$prefix = strpos( $parentMsg->get( 'subject' ), $prefix ) === 0 ? "" : $prefix;
			$tMessages->set( 'type_id',   $parentMsg->get( 'type_id' ) );
			$tMessages->set( 'subject',   $prefix.$parentMsg->get( 'subject' ) );
			$tMessages->set( 'parent_id', $parentMsg->get( 'id' ) );

			$msgChain = $mInbox->getMessageChain( $parentMsg->get( "id" ) );
		}

		$mesage_type_id = JRequest::getInt( "type_id", $tMessages->get( "type_id" ) );

		if( $mesage_type_id ) {
			$mTypes->setId( $mesage_type_id );
			$message_type = & $mTypes->getType();
		} else {
			$message_type = & $mTypes->getDefaultType();
		}

		$message_type->params = new JParameter( $message_type->params, JSPATH_INBOX_ADMIN.DS."type.xml" );
		 
		$toolbar = new JINBToolBar( 'me_message_toolbar' );

		$toolbar->sendMessage();
		$toolbar->saveInDraft();
		if ( JRequest::getWord( "context"  ) == "draft" ) {
			$toolbar->cancelCompose( "cancelDraft" );
		} else {
			$toolbar->cancelCompose( "cancelCompose" );
		}

		$document->setTitle( JText::_( 'Inbox user`s options' ) );

		$pathway->addItem( 'Compose new message', '' );

		$lists = array();

		$priorities[] = JHTML::_('select.option',  0, JText::_( 'Regular' ) );
		$priorities[] = JHTML::_('select.option',  1, JText::_( 'Low' ) );
		$priorities[] = JHTML::_('select.option',  2, JText::_( 'High' ) );
		$lists[ 'priority' ] = JHTML::_( 'select.genericlist',   $priorities, 'priority', 'class="inputbox"', 'value', 'text', JRequest::getInt( 'priority', $tMessages->get( "priority" ) ) );

		$resourceFields = array();
		if( JFolder::exists( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource' ) ) {
			require_once JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'views'.DS.'record'.DS.'view.html.php';
			require_once JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'models'.DS.'record.php';
			require_once JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php';

			$this->_fields = null;

			$resourceFields = $this->getResourceFields( $message_type );
		}

		$fields_posted_values = JRequest::getVar( 'fields', array() );

		if( count( JRequest::getVar( 'fields', array() ) ) ) {
			foreach ( $resourceFields as $key => $rfield ) {
				if( !isset( $fields_posted_values[ $rfield->id ] ) ) continue;
				$resourceFields[ $key ]->field_value = $fields_posted_values[ $rfield->id ];
			}
		}

		$additions = JRequest::getVar( "additions", array() );
		$sto = JRequest::getVar( "sto", array() );

		$group_send_access = false;
		if( class_exists( 'JSCommunityApiExtern' ) ) {
			$userGroupParty = JSCommunityApiExtern::getUserGroupParty( $user->get( "id" ) );
			$comm_params = JSCommunityApiExtern::getCommunityParams();
			$allow_groups = $comm_params->get('groups::allow_send_to_all_groups');
			if(!is_array($allow_groups)){
				settype($allow_groups, 'array');
			}
			if(in_array($user->get('gid'), $allow_groups)){
				$group_send_access = true;
			}
		}

		JHTML::_('behavior.mootools');

		$this->assignRef( 'group_send_access', $group_send_access );
		$this->assignRef( 'userGroupParty',    $userGroupParty );
		$this->assignRef( 'sto',               $sto );
		$this->assignRef( 'additions',         $additions );
		$this->assignRef( 'msgChain',          $msgChain );
		$this->assignRef( 'message',           $tMessages );
		$this->assignRef( 'type_id',           $mesage_type_id );
		$this->assignRef( 'type_params',       $message_type->params );
		$this->assignRef( 'resourceFields',    $resourceFields );
		$this->assignRef( 'lists',             $lists );
		$this->assignRef( 'user_options',      $user_options );
		$this->assignRef( 'toolbar',           $toolbar );
		$this->assignRef( 'url_params',        $url_params );
		$this->assignRef( 'action',            $uri->toString() );

		parent::display( $tpl );
	}

	function _getList( $arg1, $arg2 = null, $arg3 = null )
	{
		$mTypes = & JModel::getInstance( 'Types', 'InboxModel' );
		return $mTypes->_getList( $arg1, $arg2, $arg3 );
	}

	function getResourceFields( $message_type )
	{
		$mInbox = & JModel::getInstance( 'Inbox', 'InboxModel' );

		$arg = new stdClass();
		$arg->id = 0;
		$arg->type_id = $message_type->params->get( "resource_type_id" );

		if( $arg->type_id ) {
			$resourceFields = ResModelRecord::getFields( $arg );
		} else {
			$resourceFields = array();
		}
		

		return $resourceFields;
	}
}
