<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyMessage by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class InboxViewPresets extends JView
{
  function display($tpl = null)
  {
  	global $mainframe, $option;
  	
  	if( JRequest::getWord( "task", "" ) == "newPreset" || JRequest::getWord( "layout", "" ) == "form") {
  	  $this->_form( $tpl );
  	  return;
  	}
  	
  	$user     = & JFactory::getUser();
  	$uri 	    = & JFactory::getURI();
  	$document = & JFactory::getDocument();
  	
  	$pathway    = & $mainframe->getPathway();
  	$url_params = & $mainframe->getParams();
  	$mPresets   = & JModel::getInstance( 'Presets', 'InboxModel' );
    
  	$toolbar = new JINBToolBar( 'me_message_toolbar' );
    
    $itemid  = JRequest::getInt('Itemid');
    $cfolder = $mainframe->getUserStateFromRequest( $option.'.cfolder', 'cfolder', '',  'word' );
    $folder  = $mainframe->getUserStateFromRequest( $option.'.folder',  'folder',  '0', 'int' );
    
    $filter_order     = $mainframe->getUserStateFromRequest( $option.'.filter_presets_order',     'filter_order',     'ctime', 'cmd' );
    $filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'.filter_presets_order_Dir', 'filter_order_Dir', 'DESC',  'word' );
    
    $toolbar->newPreset();
    $toolbar->editPreset();
    $toolbar->removePreset();
    $toolbar->cancelPreset();
    
    $presets       = $mPresets->getPresets( $user->get( "id" ) );
    $total_presets = $mPresets->getTotal( $user->get( "id" ) );
    
    $pagination = $mPresets->getPagination( $total_presets );
    
    $document->setTitle( JText::_( "View Manager" ) );
    
    $lists['order_Dir'] = $filter_order_Dir;
    $lists['order']     = $filter_order;
    
    $pathway->addItem( JText::_( 'Inbox' ), JURI::root()."/index.php?option=com_jsinbox".($folder ? "&folder=".$folder : "" ).($cfolder ? "&cfolder=".$cfolder : "" ) );
    $pathway->addItem( JText::_( 'View Manager' ), "" );
    
    //$presets = $mPresets->getPresets( $user->get( "id" ) );
    
    $this->assignRef( 'toolbar',    $toolbar );
    $this->assignRef( 'presets',    $presets );
    $this->assignRef( 'lists',      $lists );
    $this->assignRef( 'url_params', $url_params );
    $this->assignRef( 'pagination', $pagination );
    $this->assignRef( 'action',     $uri->toString() );
    
    parent::display( $tpl );
  }
  
  function _form( $tpl = null )
  {
    global $mainframe, $option;
    
    $user     = & JFactory::getUser();
    $uri      = & JFactory::getURI();
    $document = & JFactory::getDocument();
    
    $pathway    = & $mainframe->getPathway();
    $url_params = & $mainframe->getParams();
    $mPresets   = & JModel::getInstance( 'Presets', 'InboxModel' );
    
    $toolbar = new JINBToolBar( 'me_message_toolbar' );
    
    $itemid  = JRequest::getInt('Itemid');
    $cfolder = $mainframe->getUserStateFromRequest( $option.'.cfolder', 'cfolder', '',  'word' );
    $folder  = $mainframe->getUserStateFromRequest( $option.'.folder',  'folder',  '0', 'int' );
    
    $toolbar->applyPreset();
    $toolbar->savePreset();
    $toolbar->cancelEditPreset();
    
    $cid = JRequest::getVar( "cid", array( 0 ) );
    if( $cid[ 0 ] == 0 ) {
      $cid[0] = JRequest::getVar( "id", 0 );
    }

    $tPresets = $mPresets->getPreset( $cid[0] );
    
    $document->setTitle( $cid[0] ? JText::_( "Edit View" ) : JText::_( "New View" ) );
    
    $pathway->addItem( JText::_( 'Inbox' ), JURI::root()."/index.php?option=com_jsinbox".($folder ? "&folder=".$folder : "" ).($cfolder ? "&cfolder=".$cfolder : "" ) );
    $pathway->addItem( JText::_( 'Views Manager' ), JURI::root()."/index.php?option=com_jsinbox&controller=presets" );
    $pathway->addItem( $cid[0] ? JText::_( "Edit View" ) : JText::_( "New View"), "" );
    
    if( JRequest::getVar( "params" ) ) {
      $preset_params = new JParameter( "", JSPATH_INBOX_ADMIN.DS."presets.xml" );
      $preset_params->loadArray( JRequest::getVar( "params" ) );
    } else {
      $preset_params = new JParameter( $tPresets->get( "params" ), JSPATH_INBOX_ADMIN.DS."presets.xml" );
    }
    
    $this->assignRef( 'user',          $user );
    $this->assignRef( 'toolbar',       $toolbar );
    $this->assignRef( 'preset',        $tPresets );
    $this->assignRef( 'lists',         $lists );
    $this->assignRef( 'url_params',    $url_params );
    $this->assignRef( 'preset_params', $preset_params );
    $this->assignRef( 'action',        $uri->toString() );
    
    parent::display( $tpl );
  }
}