<?php
/**
 * $Id$
 * $LastChangedDate$
 * $LastChangedBy$
 * MightyMessage by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
// Check to ensure this file is included in Joomla!
defined ( '_JEXEC' ) or die ( 'Restricted access' );

jimport ( 'joomla.application.component.view' );

class InboxViewRead extends JView {
	function display($tpl = null) {
		global $mainframe, $option;
		
		JHTML::_ ( 'behavior.tooltip' );
		
		$user = & JFactory::getUser ();
		$uri = & JFactory::getURI ();
		$document = & JFactory::getDocument ();
		
		$pathway = & $mainframe->getPathway ();
		$url_params = & $mainframe->getParams ();
		$mInbox = & JModel::getInstance ( 'Inbox', 'InboxModel' );
		$mFolders = & JModel::getInstance ( 'Folders', 'InboxModel' );
		$mTypes = & JModel::getInstance ( 'Types', 'InboxModel' );
		
		$itemid = JRequest::getInt ( 'Itemid' );
		
		$document->addScript ( JURI::root () . 'media/mightyextensions/js/felix_js/library.js' );
		$document->addScript ( JURI::root () . 'media/mightyextensions/js/felix_js/item_manager.js' );
		$document->addScript ( JURI::root () . 'media/mightyextensions/js/felix_js/pop_up.js' );
		$document->addScript ( JURI::root () . 'administrator/components/com_jsinbox/js/shadowbox/adapter/shadowbox-base.js' );
		$document->addScript ( JURI::root () . 'administrator/components/com_jsinbox/js/shadowbox/shadowbox.js' );
		
		$ident = JRequest::getVar ( "iid" );
		
		$message = $mInbox->getMessage ( $ident );
		
		if ($user->get('id') != $message->user_to ) {
			JError::raiseNotice(404, 'You can not view private messages of other users.');
			$link = JURI::root();
			$mainframe->redirect($link);
		}
		
		$mTypes->setId ( $message->type_id );
		
		$type = $mTypes->getType ();
		
		$type_params = new JParameter ( $type->params );
		
		if (isset ( $message->_read ) && $message->_read == "0000-00-00 00:00:00") {
			$mInbox->setRead ( $ident );
		}
		
		$msgChain = array ();
		
		if ($message->parent_id) {
			$msgChain = $mInbox->getMessageChain ( $message->parent_id );
		}
		
		$message->user_from = & JFactory::getUser ( $message->user_from );
		//$addresses = $this->parseAddresses( $message->addresses );
		

		$addressHelper = new jinbAddressShower ( );
		$addressHelper->init ( $message->addresses, $message->user_to );
				
		$document->setTitle ( $message->subject );
		
		$cfolder = $mainframe->getUserState ( $option . '.cfolder' );
		$folder_id = $mainframe->getUserState ( $option . '.folder' );
		
		$folder = $mFolders->getFolder ( $folder_id, $cfolder );
		$folders = $mFolders->getFolders ( $user );
		
		$urlFolder = $folder_id ? "&folder=" . $folder_id : "&cfolder=" . $cfolder;
		
		$pathway->addItem ( $folder->title, 'index.php?option=com_jsinbox' . $urlFolder . ($itemid ? "&Itemid=" . $itemid : "") );
		$pathway->addItem ( $message->subject, '' );
		
		$message->ctime = JFactory::getDate ( $message->ctime );
		
		
		$componentParams = new JParameter(JFile::read(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jsinbox'.DS.'config.ini'));
		
		if (JRequest::getVar ( "context" ) != "print") {
			$toolbar = new JINBToolBar ( 'me_message_toolbar' );
			switch ($cfolder) {
				default :
				case "inbox" :
				case "junk" :
					if ($type_params->get ( "allow_reply" )) {
						$toolbar->replySingle ();
						$toolbar->replySingleAll ();
					}
					if ($type_params->get ( "allow_forward" )) {
						$toolbar->forwardSingle ();
					}
					$toolbar->trashSingle ();
					$toolbar->moveSingle ( $folders, $folder );
					
					if ($componentParams->get('toolbar_show_print'))
						$toolbar->printViewSingle ();
			        if ($componentParams->get('toolbar_show_pdf'))
						$toolbar->pdfSingle ();
					$toolbar->cancelRead ();
					break;
				case "draft" :
					break;
				case "sent" :
					$toolbar->replySingle ();
					$toolbar->replySingleAll ();
					$toolbar->forwardSingle ();
					$toolbar->trashSingle ();
					if ($componentParams->get('toolbar_show_print'))
						$toolbar->printViewSingle ();
			        if ($componentParams->get('toolbar_show_pdf'))
						$toolbar->pdfSingle ();
					$toolbar->cancelRead ();
					break;
				case "trash" :
					$toolbar->restore ();
					$toolbar->delete ();
					$toolbar->cancelRead ();
					break;
			}
			$this->assignRef ( 'toolbar', $toolbar );
		}
		
		$this->assignRef ( 'msgChain', $msgChain );
		$this->assignRef ( 'addressHelper', $addressHelper );
		$this->assignRef ( 'folder', $folder );
		$this->assignRef ( 'message', $message );
		$this->assignRef ( 'url_params', $url_params );
		$this->assignRef ( 'action', $uri->toString () );
		
		parent::display ( $tpl );
	}
	
/*function parseAddresses( $xml )
  {
    $db = JFactory::getDBO();
    
    $result = array( 'find' => array( "to"=>array(), "cc"=>array() ));
    
    $registry = new JinbRegistry();
    $registry->loadJinbXML( $xml );
    $addresses = $registry->toArray();
    
    foreach ( $addresses as $field => $f_addresses ) {
      
      $to_query = array();
      foreach( $f_addresses as $key => $addr ) {
        $a = trim( $addr );
        if( !$a ) continue;
        $to_query[] = $db->getEscaped( $a ); 
      }
      $to_query = array_unique( $to_query );
       
      if( count( $to_query ) ) {
        $db->setQuery( "SELECT id, username FROM #__users WHERE username IN('".implode( "','", $to_query )."')" );
        
        $from_query = $db->loadObjectList();
        foreach( $from_query as $user ) {
          $result[ 'find' ][ $field ][] = JFactory::getUser( $user->id );
          unset( $to_query[array_search( $db->getEscaped( $user->username ), $to_query )] );
        }
        
        if( count( $to_query ) ) {
          $result[ 'unknown' ][ $field ] = $to_query;
        }
      }      
    }
    return $result;
  }*/

}